<?php
namespace Fiscal\Logic\Parametros;

use \Geral\Entities\Paramfilial;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class ParametrosFilial{

    public static function UpdateParamFilial($ativo, $cdfilial, $nrtamnumnfutdfe, $idutilallonf, $idbloqcmpsaffil, 
                                             $idperforneco, $idutctrlfisentr, $nrmaxdiaantdtaf, $nrmaxdiaposdtaf, 
                                             $idcondesbonforn, $nrorg, $data, $operador, $idutsaidprev, $idtcusnfroma,
                                             $cdfcusnfroma, $cdtpbaixarec, $cdredugbfili, $nrtamnumnfut, $cdalmoxarife,
                                             $cdlocalestoq, $idutliberanf, $idgerparcst, $idaltedescremis, $idconscalvennf,
                                             $idparamemisrefi, $idincnfvenlansv, $nrdiaposemdocst, $cdtpctreceb ,
                                             $idutctrlfis, $idutctrlfissaid, $idcancextmpnfe, $dspar) {

        /** @var $paramFilial Paramfilial */
        $paramFilial = \Geral\Entities\Paramfilial::findOneByCdfilialAndNrorg($cdfilial, $nrorg);

        $paramFilial->setIdativo($ativo);
        $paramFilial->setCdfilial($cdfilial);
        $paramFilial->setNrtamnumnfutdfe($nrtamnumnfutdfe);
        $paramFilial->setIdutilallonf($idutilallonf);
        $paramFilial->setIdbloqcmpsaffil($idbloqcmpsaffil);
        $paramFilial->setIdperforneco($idperforneco);
        $paramFilial->setIdutctrlfisentr($idutctrlfisentr);
        $paramFilial->setNrmaxdiaantdtaf($nrmaxdiaantdtaf);
        $paramFilial->setNrmaxdiaposdtaf($nrmaxdiaposdtaf);
        $paramFilial->setIdcondesbonforn($idcondesbonforn);

        $dsparfilfis = $paramFilial->getDsparfilfis();
        if($dsparfilfis == null){
            $dsparfilfis = '  '.$dspar;
        }
        else{
            $dsparfilfis[2] = $dspar;
        }

        $dspar ? $paramFilial->setDsparfilfis($dsparfilfis) : '';
        $idutsaidprev ? $paramFilial->setIdutsaidprev($idutsaidprev) : '';
        $idtcusnfroma ? $paramFilial->setIdtcusnfroma($idtcusnfroma) : '';
        $cdfcusnfroma ? $paramFilial->setCdfcusnfroma($cdfcusnfroma) : '';
        $cdtpbaixarec ? $paramFilial->setCdtpbaixarec($cdtpbaixarec) : '';
        $cdredugbfili ? $paramFilial->setCdredugbfili($cdredugbfili) : '';
        $nrtamnumnfut ? $paramFilial->setNrtamnumnfut($nrtamnumnfut) : '';
        $cdalmoxarife ? $paramFilial->setCdalmoxarife($cdalmoxarife) : '';
        $cdlocalestoq ? $paramFilial->setCdlocalestoq($cdlocalestoq) : '';
        $idutliberanf ? $paramFilial->setIdutliberanf($idutliberanf) : '';
        $idgerparcst ? $paramFilial->setIdgerparcst($idgerparcst) : '';
        $idaltedescremis ? $paramFilial->setIdaltedescremis($idaltedescremis) : '';
        $idconscalvennf ? $paramFilial->setIdconscalvennf($idconscalvennf) : '';
        $idparamemisrefi ? $paramFilial->setIdparamemisrefi($idparamemisrefi) : '';
        $idincnfvenlansv ? $paramFilial->setIdincnfvenlansv($idincnfvenlansv) : '';
        $nrdiaposemdocst ? $paramFilial->setNrdiaposemdocst($nrdiaposemdocst) : '';
        $cdtpctreceb ? $paramFilial->setCdtpctreceb($cdtpctreceb) : '';
        $idutctrlfis ? $paramFilial->setIdutctrlfis($idutctrlfis) : '';
        $idutctrlfissaid ? $paramFilial->setIdutctrlfissaid($idutctrlfissaid) : '';
        $idcancextmpnfe ? $paramFilial->setIdcancextmpnfe($idcancextmpnfe) : '';

        $paramFilial->setNrorg($nrorg);
        $paramFilial->setNrorginclusao($nrorg);
        $paramFilial->setNrorgultatu($nrorg);
        $paramFilial->setDtinclusao($data);
        $paramFilial->setDtultatu($data);
        $paramFilial->setCdoperinclusao($operador);
        $paramFilial->setCdoperultatu($operador);

        $paramFilial->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public static function NovoParamFilial($cdfilial, $nrorg) {
        try {
            /** @var $paramFilial Paramfilial */
            $paramFilial = \Geral\Entities\Paramfilial::findOneByCdfilialAndNrorg($cdfilial, $nrorg);
            if ($paramFilial instanceof Paramfilial){
                tk_abort(\Fiscal\Logic\Parametros\Exceptions\ExcecaoParametros::SalvarParamFilial());
            }else{
            	$paramFilial = new \Geral\Entities\Paramfilial();
            	$paramFilial->setCdfilial($cdfilial);
            	$paramFilial->setNrorg($nrorg);
            	
            	$paramFilial->setNrorginclusao($nrorg);
            	$paramFilial->setNrorgultatu($nrorg);
            	$paramFilial->setDtinclusao(DateUtil::getDataAtual());
            	$paramFilial->setDtultatu(DateUtil::getDataAtual());
            	$paramFilial->setCdoperinclusao(Ambiente::getCdOperador());
            	$paramFilial->setCdoperultatu(Ambiente::getCdOperador());

            	$paramFilial->setIdincnfvenlansv('N');
            	$paramFilial->setIdparamemisrefi('N');
            	$paramFilial->setIdobrigaajuinve('F');
            	$paramFilial->setIdpermvisposest('S');
            	$paramFilial->setIdcalcrecbruta('N');
            	$paramFilial->setIdutctrlfis('N');
            	$paramFilial->setIdblqefediafech('N');
            	$paramFilial->setIdobrealacediv('N');
            	$paramFilial->setIdbloqfecinvpe('N');
            	$paramFilial->setIdutctrlfisentr('N');
            	$paramFilial->setIdutctrlfissaid('N');
            	$paramFilial->setIdaltdtprocfdia('N');
            	$paramFilial->setIdativo('S');
            	$paramFilial->setIdacesalmoxdest('N');
            	$paramFilial->setIdbloqtransfest('N');
            	$paramFilial->setIdcancextmpnfe('N');
                $paramFilial->setIdreinicianumre('N');
            	$paramFilial->setIdlancdtmenfil('N');
            	$paramFilial->setDtultatupafi(DateUtil::getDataAtual());
            	$paramFilial->setIdbloqcmpsaffil('N');
            	$paramFilial->setIdaltedescremis('S');
            	$paramFilial->setIdutretbaseinve('N');
            	$paramFilial->setIdcopaltefepla('N');
            	$paramFilial->setIdcondesbonforn('S');
            	$paramFilial->setIdutmodprodfil('N');
            	$paramFilial->setIdutbloqopafpf('N');
            	$paramFilial->setIdlancdtmaifil('N');
            	$paramFilial->setIdinvestcego('N');
            	$paramFilial->setIDCONSCALVENNF('F');
            	
            	$paramFilial->persist();
            	\Setforms2\Shared\Registry::getEntityManager()->flush();
            }
        } catch (\Exception $e) {
            throw $e;
        }


    }
}
