// FILE: ./assets/js/repositories/Sup00800_Fornecedor_Repository.js
var Sup00800_Fornecedor_Repository = function(localStorageEngine, restEngine) {
    
    var self = this;

    self.removePrazoPagamento = function (data) {
        return restEngine.post('cadSup#/crud/prazopgtforn/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.removeFormaPagamento = function (data) {
        return restEngine.post('cadSup#/crud/prazopgtforn/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.savePrazoPagamento = function (data) {
        return restEngine.post('cadSup#/crud/prazopgtforn/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.getParceria = function(parceria, tipoParceria){
        return restEngine.post('cadSup#/crud/parceria',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceria
                    },
                    {
                        "name": "CDTIPOPARCEIRO",
                        "operator": "=",
                        "value": tipoParceria
                    }
                ]
            }
        );
    };

    self.getEnderecoParcNegocio = function (parceiro, tipoEndereco) {
        return restEngine.post('cadSup#/crud/enderecoparc',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceiro
                    },
                    {
                        "name": "CDTIPOENDERECO",
                        "operator": "=",
                        "value": tipoEndereco
                    }
                ]
            }
        );
    };

    self.getParcNegocio = function (inscricao) {
        return restEngine.post('cadSup#/crud/parcnegocio',
            {
                "requestType": "FilterData", 
                "filter": [
                    {
                        "name": "NRINSCRICAOPARC",
                        "operator": "=",
                        "value": inscricao
                    }
                ]
            }
        );
    };

    self.insereParceria = function(parceria){
        return restEngine.post('cadSup#/crud/parceria/save',
            {
                "requestType": "DataSet",
                "dataset": parceria
            }
        );
    };

    self.insereEnderecoParceiro = function(data){
        return restEngine.post('cadSup#/crud/enderecoparc/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereParceiro = function(data){
        return restEngine.post('cadSup#/crud/parcnegocio/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereContaCorrenteFornecedor = function(data){
        return restEngine.post('cadSup#/crud/ccorforn/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00800_Fornecedor_Repository', Sup00800_Fornecedor_Repository);
});

// FILE: ./assets/js/repositories/Sup02400_ParamfilialRepository.js
Configuration(function(RepositoryFactory, ContextRegister, Query) {

	var Sup02400_ParamfilialRepository = RepositoryFactory.factory('/crud/paramfilial', 'LOCAL', 1, 30000);

	Sup02400_ParamfilialRepository.getParamfilial = function(nrorg, cdfilial) {
		// console.log(Sup02400_ParamfilialRepository);
		return this.download(Query.build()
			.where('nrorg').equals(nrorg)
			.where('cdfilial').equals(cdfilial)
		);
	}; 

	ContextRegister.register('Sup02400_ParamfilialRepository', Sup02400_ParamfilialRepository);

});

// FILE: ./assets/js/services/Constants.js

if (typeof Constants === "undefined") {
	var Constants = {
		successNotification: {
			type: "success"
		},

		successMessage: {
			type: "success",
			icon: "checked"
		},

		errorNotification: {
			type: "error"
		},

		errorMessage: {
			type: "error",
			icon: "error"
		},

		alertMessage: {
			type: "alert",
			icon: "exclamation"
		},

		infoMessage: {
			type: "information",
			icon: "information"
		},

		confirmationMessage: {
			type: "question",
			icon: "question"
		}
	};
}

// FILE: ./assets/js/services/Sup00800_Fornecedor_Service.js
var Sup00800_Fornecedor_Service = function(Sup00800_Fornecedor_Repository) {
    
    var self = this;

    self.removePrazoPagamento = function (data) {
       return Sup00800_Fornecedor_Repository.removePrazoPagamento(data);
    };

    self.removeFormaPagamento = function (data) {
        return Sup00800_Fornecedor_Repository.removeFormaPagamento(data);
    };

    self.savePrazoPagamento = function (data) {
        return Sup00800_Fornecedor_Repository.savePrazoPagamento(data);
    };

    self.getEnderecoParcNegocio = function(parceiro, tipoEndereco){
        return Sup00800_Fornecedor_Repository.getEnderecoParcNegocio(parceiro, tipoEndereco);
    };

    self.getParceria = function(parceria, tipoParceria){
        return Sup00800_Fornecedor_Repository.getParceria(parceria, tipoParceria);
    };

    self.getParcNegocio = function(inscricao){
        return Sup00800_Fornecedor_Repository.getParcNegocio(inscricao);
    };

    self.insereParceria = function(parceria){
        return Sup00800_Fornecedor_Repository.insereParceria(parceria);
    };
 
    self.insereEnderecoParceiro = function(endereco){
        return Sup00800_Fornecedor_Repository.insereEnderecoParceiro(endereco);
    };

    self.insereParceiro = function(data){
        return Sup00800_Fornecedor_Repository.insereParceiro(data);
    };

    self.insereContaCorrenteFornecedor = function(contacorrente){
        return Sup00800_Fornecedor_Repository.insereContaCorrenteFornecedor(contacorrente);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00800_Fornecedor_Service', Sup00800_Fornecedor_Service);
});

// FILE: ./assets/js/services/Sup02400_CalendarioDeDiasNaoUteis_Service.js
var Sup02400_CalendarioDeDiasNaoUteis_Service = function (ScreenService, templateManager, restEngine, localStorageEngine) {
  
    this.findCalendario = function(filter, calendarioOption){
        switch(calendarioOption){
            case 'filial' :
                filter[2].name = "DTFERIFILI";
                return this.findFilial(filter);
            case 'compras' : 
                filter[2].name = "DTFERICOMP";
                return this.findCompras(filter);
            case 'bancario':
                filter[2].name = "DTFERIBANC";
                return this.findBancario(filter);
            case 'cardapio':
                filter[2].name = "DTFERICARD";
               return this.findCardapio(filter);
        }
    };
    this.verificaDia = function(data){
        return restEngine.post("cadSup#/calendario/verificaDia", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    this.saveCalendario = function(data){
        return restEngine.post("cadSup#/calendario/save", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
	this.findFilial = function (filter){
	    
        return restEngine.post("cadSup#/crud/ferifili", {
            "requestType": "FilterData",
            "filter": filter
        });
	};

    this.findCompras = function (filter){
        
        return restEngine.post("cadSup#/crud/fericomp", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.findBancario = function (filter){
        
        return restEngine.post("cadSup#/crud/feribanc", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.findCardapio = function (filter){
        
        return restEngine.post("cadSup#/crud/fericard", {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.excluirDia = function (data){

        return restEngine.post("cadSup#/calendario/remove", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.deleteCardapio = function (row){
        
        return restEngine.post("cadSup#/calendario/removeCardapio", {
            "requestType": "Row",
            "row": row
        }); 
    };

    this.exportarCalendario = function (data){
        
        return restEngine.post("cadSup#/calendario/exportarCalendario", {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.calculoCompras = function(data){
        return restEngine.post("cadSup#/calendario/calculoCompras", {
            "requestType": "DataSet",
            "dataset": data
        });
    };


};

Configuration(function(ContextRegister, eventEngine) {
	ContextRegister.register('Sup02400_CalendarioDeDiasNaoUteis_Service', Sup02400_CalendarioDeDiasNaoUteis_Service);
});

// FILE: ./assets/js/services/Sup02400_ParamfilialService.js
var Sup02400_ParamfilialService = function(Sup02400_ParamfilialRepository) {

	this.getParamfilial = function(nrorg, cdfilial) {
		return Sup02400_ParamfilialRepository.getParamfilial(nrorg, cdfilial);
	};

	this.getDtprocessa = function(nrorg, cdfilial) {
		return this.getParamfilial(nrorg, cdfilial).then(function(paramfilial) {
			return paramfilial[0];
		});
	}; 

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup02400_ParamfilialService', Sup02400_ParamfilialService);
});

// FILE: ./assets/js/controllers/Ger02400_Dias_Nao_Uteis_Controller.js
function Ger02400_Dias_Nao_Uteis_Controller(Sup02400_ParamfilialService, ScreenService, MessageService, General, ZHPromise, Sup02400_CalendarioDeDiasNaoUteis_Service,localStorageEngine, templateManager, ZhFilterPreferences) {
    var self = this;
    var tabCal;
    var DTPROCE;
    var NRORG;
    var CDFILIAL;
    var TABS = {
        "filial": {
            DTFERI: "DTFERIFILI",
            DSFERI: "DSFERIFILI",
            TABFERI: "ferifili",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTULTATUFEFI"
        },
        'compras': {
            DTFERI: "DTFERICOMP",
            DSFERI: "DSFERICOMP",
            TABFERI: "fericomp",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTULTATUFECO"
        },
        'bancario': {
            DTFERI: "DTFERIBANC",
            DSFERI: "DSFERIBANC",
            TABFERI: "feribanc",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTINCLUSAO"
        },
        'cardapio': {
            DTFERI: "DTFERICARD",
            DSFERI: "DSFERICARD",
            TABFERI: "fericard",
            DTINC: "DTINCLUSAO",
            DTULTA: "DTINCLUSAO"
        }
    };
    
    const CalendarService = Sup02400_CalendarioDeDiasNaoUteis_Service;
    
    this.selecionaCalendario = function (args) {
        if (args.owner.widget.isValid()) {
            
            NRORG = getLocalVar('NRORGTRAB') ? getLocalVar('NRORGTRAB') : getLocalVar('NRORG');
            CDFILIAL = args.owner.widget.currentRow.CDFILIAL ? args.owner.widget.currentRow.CDFILIAL : getLocalVar('CDFILIAL');
            var stripeWidget = args.owner.widget.container.getWidget('stripeWidget');
            tabCal = args.owner.widget.currentRow.calendario;
            this.verificaCalendario(stripeWidget, tabCal);
            stripeWidget.currentRow.CDFILIAL = CDFILIAL;
            var ano = args.owner.widget.currentRow.ANO;
            carregaCalendario(args.owner.widget, ano);
            var cdFilial = args.owner.widget.currentRow.CDFILIAL;
            var nmFilial = args.owner.widget.currentRow.NMFILIAL;
            var data = new Date();
            
            Sup02400_ParamfilialService.getDtprocessa(NRORG, CDFILIAL).then(function(callback) {
                ScreenService.closePopup('stripeWidget');
                DTPROCE = callback.DTPROCESSA ? data.getDateBr() : moment(callback.DTPROCESSA, 'DD/MM/YYYY HH:mm:ss').format('DD/MM/YYYY');
                args.owner.widget.container.getWidget('calendario').activate();
                setLocalVar('CDFILIALFILTRO', cdFilial);
                setLocalVar('NMFILIALFILTRO', nmFilial);
                setLocalVar('DTPROCESSAFILTRO', DTPROCE);
                args.owner.widget.container.getWidget('calendario').actions.forEach(function(action){
                    action.isVisible = true;
                });
            });
        }
    };
    
    this.verificaCalendario = function (widget, value) {
        switch (value) {
            case 'filial':
                widget.currentRow.calendarioOp = "Unidade";
            break;
            case 'compras':
                widget.currentRow.calendarioOp = "Compras"; 
            break;
            case 'bancario':
                widget.currentRow.calendarioOp = "Bancário";
            break;
            case 'cardapio':
                widget.currentRow.calendarioOp = "Cardápio (Feriado)";
            break;
        }
    };
    
    const verificaErroDia = function(widget) {

        var row = {
            CDFILIAL,
            DTDIA: moment(widget.currentRow.DATA).format('DD/MM/YYYY')
        };
        
        let aux = true;
        
        General.callRestEngine('cadSup#/calendario/verificaErroDia','Row', row).then(function(res){
            var data = [];
            if(!tabCal) {
                MessageService.showMessageByCode("utilizarFuncoes", null, Constants.infoMessage).then(function(){
                    ScreenService.openPopup(widget.container.getWidget('stripePopup'));
                });
            } else {
                if (tabCal == "filial") {
                    data = [{
                        "DTDIA": moment(widget.currentRow.DATA).format('DD/MM/YYYY'),
                        "DTPROCE": DTPROCE,
                        "TABCAL": tabCal,
                        "CDFILIAL": CDFILIAL,
                        "NRORG": NRORG
                    }];

                    return CalendarService.verificaDia(data).then(function(callback) {
                        var response = callback.dataset.resp[0].filial;
                        
                        if(response.length != 0 && !response.ERRORMSG){
                            var date1 = response.DTCARDIAPME;
                            var date2 = response.DTPROCE;
                            
                            date1 = date1.split("/");
                            date2 = date2.split("/");
                            
                            date1 = new Date(date1[1] + "/" + date1[0] + "/" + date1[2]);
                            date2 = new Date(date2[1] + "/" + date2[0] + "/" + date2[2]);
                            
                            if (date1 < date2){
                                widget.reload();
                            	General.widgetCancelForm(widget);
        	                    return MessageService.showMessageByCode("ERRODTPROCESSAMENTODIASNAOUTEIS", null, Constants.errorMessage);
                            } 
                        }

                        if (response.ERRORMSG) {
                            widget.reload();
                        	General.widgetCancelForm(widget);
                            return MessageService.showMessageByCode(response.ERRORMSG, null, Constants.errorMessage);
                        }
                            
                        if (response.MSG) {
                            if (response.TYPE == 'industrial') {
                                MessageService.confirmMessageByCode(response.MSG).then(function() {
                                    
                                    CalendarService.deleteCardapio(response).then(function() {
                                         salvar(widget);
                                    }.bind(this), function(error){
                                        showGenericError(error);
                                    });
                                }.bind(this));
                            } else if (response.TYPE == 'merenda') {
                                MessageService.confirmMessageByCode(response.MSG).then(function() {
                                    if (response.CDFILIAL == response.CDFILCENTPME) {
                                        MessageService.confirmMessageByCode("unidadeSelecionada").then(function() {
                                            CalendarService.deleteCardapio(response).then(function(callback){
                                                salvar(widget);
                                            }.bind(this), function(error){
                                                showGenericError(error);
                                            });
                                        }.bind(this));
                                    } else {
                                        CalendarService.deleteCardapio(response).then(function(){
                                             salvar(widget);
                                        }.bind(this), function(error){
                                            showGenericError(error);
                                            return false;
                                        });
                                    }
                                }.bind(this));
                            } 
                        }else {
                             salvar(widget);
                        }
                    }.bind(this));
                } else {
                    salvar(widget);
                }
            }
        }, function(err) {
            aux = false;
            widget.reload();
        	General.widgetCancelForm(widget);
            ScreenService.showMessage(err.data.error);
        });
        return aux;
    };

    this.cancelFilter = function(widget){
        var calendario = widget.container.getWidget('calendario');
        if(!tabCal){
            calendario.actions.forEach(function(action){
                action.isVisible = false;
            });
        }
        ScreenService.closePopup();
        calendario.list();
        calendario.activate();
    };
    
    this.resetWidget = function(widget){
        widget.selectedDates = [];
        widget.list();
    };
    
    const carregaCalendario = function (widget, ano) {
        var calendarWidget = widget.container.getWidget('calendario');
        var data = [];
        var year = ano ? ano : calendarWidget.getYear();
        var mes = ano && ano != moment().format('YYYY') ? 0 : calendarWidget.getMonth();
        var dateInit = moment(year, 'YYYY').startOf('year').format('DD/MM/YYYY');
        var dateFinal = moment(year, 'YYYY').endOf('year').format('DD/MM/YYYY');
        var filter = [{
            "name": "NRORG",
            "operator": "=",
            "value": NRORG
        }, 
        {
            "name": "CDFILIAL",
            "operator": "=",
            "value": CDFILIAL
        }, 
        {
            "name": "",
            "operator": "BETWEEN",
            "value": [dateInit, dateFinal]
        }
        ];
        CalendarService.findCalendario(filter, tabCal).then(function(callback) {
            var dias;
            dias = callback.dataset[TABS[tabCal].TABFERI];
            dias.forEach(function(dataset) {
                var dateFormat = moment(dataset[TABS[tabCal].DTFERI].slice(0, 10), "DD/MM/YYYY");
                var DTINC = TABS[tabCal].DTINC;
                var DTULTA = TABS[tabCal].DTULTA;
                data.push({
                    TITLE: dataset[TABS[tabCal].DSFERI],
                    DATE: dateFormat.format("YYYY-MM-DD"),
                    DTINC: dataset[TABS[tabCal].DTINC],
                    DTULTA: dataset[TABS[tabCal].DTULTA],
                    NRORGINCLUSAO: dataset.NRORGINCLUSAO,
                    CDOPERINCLUSAO: dataset.CDOPERINCLUSAO,
                    NRORGULTATU: dataset.NRORGULTATU,
                    IDATIVO: dataset.IDATIVO
                });
            });
            calendarWidget.dataSource.data = data;
            calendarWidget.getCurrentDate().month(mes);
            calendarWidget.getCurrentDate().year(year);
            if (widget.mode != "view") {
                calendarWidget.reload().then(function() {
                    calendarWidget.activate();
                });
            }
        },function(callback){
            MessageService.showMessageByCode("errorCalendario", null, Constants.errorMessage);
        });
    };
    
    this.editar = function (widget) {
        widget.edit();
        widget.template = widget.formTemplate = widget.templateToForm;
    };

    this.deleteCardapio = function(row) {
        return CalendarService.deleteCardapio(row);
    };
    this.excluirDia = function(widget) {
        var rows = widget.currentRow;
        var calendar;
        var data = [];
        if (Array.isArray(rows)) {
            calendar = widget.container.getWidget('cadastroAuto').currentRow.calendario;
            for (var key in rows) {
                var DRow = {};
                DRow.DATA = rows[key];
                DRow[TABS[calendar].DTFERI] = moment(rows[key], "YYYY/MM/DD").format('DD/MM/YYYY');
                DRow.CDFILIAL = CDFILIAL;
                DRow.TABCAL = calendar;
                DRow.TABS = TABS;
                DRow.NRORG = NRORG;
                DRow.__is_new = false;
                data.push(DRow);
            }
        } else {
            var Srow = {};
            Srow.CDFILIAL = CDFILIAL;
            Srow[TABS[tabCal].DTFERI] = moment(rows.DATA, "YYYY/MM/DD").format('DD/MM/YYYY');
            Srow.TABCAL = tabCal;
            Srow.TABS = TABS;
            Srow.NRORG = NRORG;
            Srow.__is_new = false;
            data.push(Srow);
        }
        CalendarService.excluirDia(data).then(function(callback) {
            carregaCalendario(widget);
            ScreenService.closeSwipe();
            var calendario = widget.container.getWidget('calendario');
            calendario.list();
            calendario.activate();
            MessageService.successNotificationByCode('successOperation');
        }.bind(this), function(callback){
            MessageService.showMessageByCode("errorExclusao", null, Constants.errorMessage);
        });
    };

    this.excluirDiaTodos = function (widget) {
        var tabelas = ['filial', 'compras', 'bancario', 'cardapio'];
        var data = [];
        var rows = widget.currentRow;
        for (var tab in tabelas) {
            if (Array.isArray(rows)) {
                for (var key in rows) {
                    var DRow = {};
                    DRow.DATA = rows[key];
                    DRow[TABS[tabelas[tab]].DTFERI] = moment(rows[key], "YYYY/MM/DD").format('DD/MM/YYYY');
                    DRow.CDFILIAL = CDFILIAL;
                    DRow.TABS = TABS;
                    DRow.NRORG = NRORG;
                    DRow.TABCAL = tabelas[tab];
                    DRow.__is_new = false;
                    data.push(DRow);
                }
            } else {
                var SRow = {};
                SRow.CDFILIAL = CDFILIAL;
                SRow[TABS[tabelas[tab]].DTFERI] = moment(rows.DATA, "YYYY/MM/DD").format('DD/MM/YYYY');
                SRow.TABCAL = tabelas[tab];
                SRow.TABS = TABS;
                SRow.NRORG = NRORG;
                SRow.__is_new = false;
                data.push(SRow);
            }
        }
        
        CalendarService.excluirDia(data).then(function(callback) {
            carregaCalendario(widget);
            ScreenService.closeSwipe();
            var calendario = widget.container.getWidget('calendario');
            calendario.list();
            calendario.activate();
            MessageService.successNotificationByCode('successOperation');
        }.bind(this), function(callback){
            MessageService.showMessageByCode("errorExclusao", null, Constants.errorMessage);
        });
    };

    this.excluirDiaNaoUtil = function(widget) {
        const stripe = widget.container.getWidget('stripePopup');
        let calendar;
        let labelSim;
		let labelNao;
		let labelUnidade;
		let actions;
		
        if (Array.isArray(widget.currentRow)) {
            calendar = widget.container.getWidget('cadastroAuto').currentRow.calendario;
        } else {
            calendar = stripe.currentRow.calendario;
        }
        
        MessageService.getMessageByCode("msgSim").then( message => {
			labelSim = message;
            
            MessageService.getMessageByCode("msgNao").then( message => {
    			labelNao = message;
    			
    			MessageService.getMessageByCode("somenteUnidade").then( message => {
        			labelUnidade = message;
        			
        			if(calendar === 'filial'){
                        actions = [{
                            label: labelSim,
                            code: function() {
                                this.excluirDiaTodos(widget);
                            }.bind(this)
                        }, {
                            label: labelUnidade,
                            code: function() {
                                this.excluirDia(widget);
                            }.bind(this)
                        }, {
                            label: labelNao,
                            code: function() {
                                this.closeCadastroAuto(widget);
                            }.bind(this)
                        }];

                        MessageService.showCustomDialogByCode('excluirDia', null, {
                            type: 'question',
                            actions: actions
                        });
                    } else {
                        actions = [{
                            label: labelSim,
                            code: function() {
                                this.excluirDia(widget, calendar);
                            }.bind(this)
                        }, {
                            label: labelNao,
                            code: function() {
                                this.closeCadastroAuto(widget);
                            }.bind(this)
                        }];
                        
                        MessageService.getMessageByCode("msg"+stripe.currentRow.calendario).then( message => {
                            const params = {
                                PARAMS: message
                            };
                            MessageService.showCustomDialogByCode('excluirDiaUtil', params, {
                                type: 'question',
                                actions: actions
                            });
                        });
                    }
        		});
    		});
		});
    };
    
    this.closeCadastroAuto = function(widget){
        const calendario = widget.container.getWidget('calendario');
        
        ScreenService.closeSwipe();
        calendario.list();
        calendario.activate();
    };
    
    this.cancelar = function(widget) {
        var mainWidget = widget.container.getWidget('calendario');
        
        if (widget.currentRow.__is_new) {
            ScreenService.closeSwipe().then(function(){
                self.resetWidget(mainWidget);
            });
        } else {
            widget.view();
            widget.template = widget.formTemplate = widget.templateToView;
            widget.activate();
        }
    };
    
    this.voltar = function(widget) {
        ScreenService.closeSwipe();
        widget.container.getWidget('calendario').activate();
    };
    
    var getWidgetByName = function (/*object*/ widget, /*string*/ nameOfWidgetToFind) {
        var widgetToReturnArray = widget.widgets.filter(function (currentWidget) {
        
        if(currentWidget.name === nameOfWidgetToFind)
                return true;
        });
        
        if(widgetToReturnArray)
            return widgetToReturnArray[0];
        else 
            return undefined;
    };
    
    this.openAutoOperation = function(widget, name) {
        var tabbedAutoOperationWidget = getWidgetByName(widget, name);
        var autoOperationWidget = tabbedAutoOperationWidget.widgets[0];
        
        autoOperationWidget.template = autoOperationWidget.formTemplate = autoOperationWidget.templateToForm;
        autoOperationWidget.edit();
        autoOperationWidget.newRow();
        autoOperationWidget.applyDefaultValue();
        ScreenService.openSwipe(tabbedAutoOperationWidget);
        autoOperationWidget.activate();
    };

    this.confirmOperation = function(widget) {
        if (widget.isValid()) {
            var row = widget.currentRow;
            var weekdays = [];
            weekdays.push(row.segunda, row.terca, row.quarta, row.quinta, row.sexta, row.sabado, row.domingo);
            var count = 0;
            for (var i in weekdays) {
                if (weekdays[i] == 'N')
                    count++;
            }
            if (count == 7) {
                MessageService.showMessageByCode("diasInformados", null, Constants.infoMessage);
            } else {
                row.weekdays = weekdays;
                if (widget.currentRow.operacao == 1) {
                    this.autoOperation(widget, 1);
                } else if (widget.currentRow.operacao == 2) {
                    this.autoOperation(widget, 2);
                }
            }
            widget.container.getWidget('calendario').activate();
        }
    };
    
    this.confirmCalculo = function(widget){
        if(widget.isValid()){
            var row = widget.currentRow;
            var months = [];
            var datas = [];
            var dataInicial = moment('01/01/'+row.ANO, 'DD/MM/YYYY');
            months.push(row.janeiro, row.fevereiro, row.marco, row.abril, row.maio, row.junho, row.julho,row.agosto, row.setembro, row.outubro, row.novembro, row.dezembro);
            var count = 0;
            for (var i in months) {
				if (months[i] === false){
			        count++;
			    }else{
			        datas.push(dataInicial.add(i, 'month').format('DD/MM/YYYY'));
			    }
            }
            if (count == 12) {
                MessageService.showMessageByCode("infomadoDiaMes", null, Constants.infoMessage);
            } else {
                var dataset = {};
            	var ALLMONTHSARESELECTED = count === 0 ? true : false;
                var DTPROCESSA = getLocalVar('DTPROCESSAFILTRO');
                
                dataset.CDFILIAL = row.CDFILIAL;
                dataset.DATAS = datas;
                dataset.ALLMONTHSARESELECTED = ALLMONTHSARESELECTED;
                dataset.DTPROCESSA = DTPROCESSA;
                dataset.ALLPERIENTR = row.CDPERIENTR && Array.isArray(row.CDPERIENTR) ? 'N': 'Y';
                if(dataset.ALLPERIENTR === 'N'){
                    var PERIODOS = '_';
                    row.CDPERIENTR.forEach(function(period){
                        PERIODOS += period+'_';
                    });
                    dataset.PERIODOS = PERIODOS;
                }
                
                CalendarService.calculoCompras([dataset]).then(function(callback){
                    MessageService.successNotificationByCode('successOperation');
                    ScreenService.closeSwipe();
                    widget.container.getWidget('calendario').activate();
                }, function(callback){
                    MessageService.showMessageByCode("erroCalcular", null, Constants.errorMessage);
                });
            }
        }
    };

    this.confirmExportacao = function(widget) {
        if (widget.isValid()) {
            var row = widget.currentRow;
            var widgetCalendario = widget.container.getWidget('calendario');
            var months = [];
            months.push(row.janeiro, row.fevereiro, row.marco, row.abril, row.maio, row.junho, row.julho,row.agosto, row.setembro, row.outubro, row.novembro, row.dezembro);
            var count = 0;
            var meses = [];
            
            for (var i in months) {
                if (months[i] === false){
                    count++;
                } else {
                    meses.push(("" + (Number(i) + 1)).padStart(2,0));
                    //meses.push((""+(Number(i)/*parseInt(i, 10)*/+1)).padStart(2,0));
                }
            }
            
            if (count == 12) {
                MessageService.showMessageByCode("informadoMes", null, Constants.infoMessage);
            } else {
                meses = meses.join('_');
                var dataset = {};
                var datas = [];
                var DTPROCESSA = getLocalVar('DTPROCESSAFILTRO');
               
                DTPROCESSA = moment(DTPROCESSA, 'DD/MM/YYYY HH:mm:ss').format('YYYY-MM-DD');
                widgetCalendario.dataSource.data.forEach(function(dados){
                    var data = moment(dados.DATE);
                    if(months[data.month()]){
                        datas.push(
                            {
                                "data": data.format('DD/MM/YYYY'), 
                                "descricao": dados.TITLE ? dados.TITLE : ""
                            }
                        );
                    }
                });
                
                if(datas.length === 0){
                    MessageService.showMessageByCode("naoHaDia", null, Constants.infoMessage);
                } else {
                    MessageService.getMessageByCode("msgConfirm").then( messageConfirm => {
                        MessageService.getMessageByCode("msgCancel").then( messageCancel => {
			                var actions = [{
                                label: messageConfirm,
                                code: function(success){
                                    dataset.ACAO = row.ACAO;
                                    dataset.ALLFILIAL = row.CDFILIALDESTINO && Array.isArray(row.CDFILIALDESTINO) ? false : true;
                                    dataset.ANO = row.ANO;
                                    dataset.CALENDARIO = row.tipo;
                                    dataset.CDFILIDESTINO = row.CDFILIALDESTINO;
                                    dataset.CDFILIORIGEM = row.CDFILIAL;
                                    dataset.GRUPFILI = row.CDGRUPFILI ? row.CDGRUPFILI : 'T';
                                    dataset.CDOPERADOR = getLocalVar('CDOPERADOR');
                                    dataset.MESES = meses;
                                    CalendarService.exportarCalendario([dataset]).then(function(callback){
                                        if(callback.messages){
                                            MessageService.successNotificationByCode('successOperation');
                                            ScreenService.closeSwipe();
                                            widget.container.getWidget('calendario').activate();
                                        } else {
                                            MessageService.showMessageByCode("errorExport", null, Constants.errorMessage);
                                        }
                                    }, function(callback){
                                        MessageService.showMessageByCode("errorExport", null, Constants.errorMessage);
                                    });
                                }.bind(this)
                            }, {
                                label: messageCancel,
                                code: function(e, deferred) {
                                    deferred.reject(e);
                                }
                            }];
                            
                            MessageService.showCustomDialogByCode('exportAtention', null, {
                                type: 'question',
                                actions: actions
                            });
                        });
                    });
                }
            }
        }
    };
    
    this.setDataSourceFilter = function(widget, clear){
        var row = widget.currentRow;
        var CDGRUPFILI;
        
        if(widget.getField('GRUPFILI').value()){
            CDGRUPFILI = row.CDGRUPFILI;
        }else{
            CDGRUPFILI = 'T';
            row.CDGRUPFILI = '';
        }
        
        widget.getField('CDFILIALDESTINO').dataSourceFilter = [
            {
                "name": "P_CDFILIAL", 
                "operator": "=", 
                "value": row.CDFILIAL || 'T'
            },
            {
                "name": "P_CDOPERADOR", 
                "operator": "=", 
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "P_CDGRUPFILI", 
                "operator": "=", 
                "value": CDGRUPFILI
            }
        ];
        widget.getField('CDFILIALDESTINO').reload();
        if(clear){
            widget.getField('CDFILIALDESTINO').clearValue();
        }
    };
    
    this.verificaDia = function(widget) {
        var dados= [];
        var data = [];
        
        if(!tabCal) {
            MessageService.showMessageByCode("utilizarFuncoes", null, Constants.infoMessage).then(function(){
                ScreenService.openPopup(widget.container.getWidget('stripePopup'));
            });
        } else {

            if (Array.isArray(widget.currentRow)) {
                var verificaPromises = [];
                var days = widget.currentRow;
                for (var day in days) {
                    data = {
                        "DTDIA": moment(days[day], 'YYYY/MM/DD').format('DD/MM/YYYY'),
                        "DTPROCE": DTPROCE,
                        "TABCAL": "filial",
                        "CDFILIAL": CDFILIAL,
                        "NRORG": NRORG
                    };
                    dados.push(data);
                }
                return CalendarService.verificaDia(dados).then(function(callback) {
                    verificaPromises = callback.dataset.resp;
                    return ZHPromise.all(verificaPromises).then(function(callback) {
                        var daysToSave = [];
                        var response = [];
                        
                        for (var key in callback) {
                            if (!Array.isArray(callback[key].filial)) {
                                if (!callback[key].filial.ERRORMSG) {
                                    response.push({
                                        "CDFILCENTPME": callback[key].filial.CDFILCENTPME,
                                        "CDFILIAL": callback[key].filial.CDFILIAL,
                                        "DTPROCE": callback[key].filial.DTPROCE,
                                        "DTCARDAPIO": callback[key].filial.DTCARDAPIO,
                                        "MSG": callback[key].filial.MSG,
                                        "TYPE": callback[key].filial.TYPE
                                    });
                                }
                            }
                            if (!callback[key].filial.ERRORMSG) {
                                daysToSave.push(days[key]);
                            }
                        }
                        if (response.length) {
                           
                            return  MessageService.confirmMessageByCode("existemCardapios").then(function() {
                                CalendarService.deleteCardapio(response);
                                return daysToSave;
                            }.bind(this), function() {
                                return false;
                            });
                        } else {
                            return daysToSave;
                        }
                    }.bind(this));
                }.bind(this));
            }
        }
    };
    
    this.verificaDiaSalva = function(widget) {

        if(!verificaErroDia(widget)){
            return;
        }

    };
    
    this.verificaProjeto = function(widget) {
        if(window.projectCorp){
                widget.getField('NMFILIAL').readOnly = false;
        }else {
                widget.getField('NMFILIAL').readOnly = true;
        }
        widget.currentRow.calendario = tabCal || 'filial';
        
        var ano = widget.container.getWidget('calendario').getYear();
        if(widget.getField('ANO')){
            widget.getField('ANO').setValue(ano);
        }
    };

    const salvar = function(widget, cadAuto, table) {
        var mainWidget = widget.container.getWidget('calendario');
        var promise;
        
        if (cadAuto) {
            var dias = widget.currentRow;
            var data;
            var row;
            if (table == "filial") {
                data = [];
                for (var diaF in dias) {
                    row = {};
                    row.__is_new = true;
                    row.CALENDAR = table;
                    row.NRORG = NRORG;
                    row.CDFILIAL = CDFILIAL;
                    row.TABS = TABS;
                    row[TABS[table].DTFERI] = moment(dias[diaF], 'YYYY/MM/DD').format('DD/MM/YYYY');
                    row[TABS[table].DSFERI] = null;
                    data.push(row);
                }
                promise = CalendarService.saveCalendario(data);
            } else if (Array.isArray(table)) {
                data = [];
                for (var i in table) {
                    for (var diaT in dias) {
                        row = {};
                        row.__is_new = true;
                        row.CALENDAR = table[i];
                        row.CDFILIAL = CDFILIAL;
                        row.NRORG = NRORG;
                        row.TABS = TABS;
                        row[TABS[table[i]].DTFERI] = moment(dias[diaT], 'YYYY/MM/DD').format('DD/MM/YYYY');
                        row[TABS[table[i]].DSFERI] = null;
                        data.push(row);
                    }
                }
                return ZHPromise.all(CalendarService.saveCalendario(data));
            } else {
                data = [];
                for (var dia in dias) {
                    row = {};
                    row.__is_new = true;
                    row.CALENDAR = table;
                    row.CDFILIAL = CDFILIAL;
                    row.NRORG = NRORG;
                    row.TABS = TABS;
                    row[TABS[table].DTFERI] = moment(dias[dia], 'YYYY/MM/DD').format('DD/MM/YYYY');
                    row[TABS[table].DSFERI] = null;
                    data.push(row);
                }
                return ZHPromise.all(CalendarService.saveCalendario(data));
            }
        } else {
            var dataset = [];
            var datas = widget.container.getWidget('calendario').dataSource.data;
            if (tabCal == "filial") {
                for (table in TABS) {
                    widget.currentRow.CALENDAR = table;
                    for (var dt in datas) {
                        if (datas[dt].DATE == widget.currentRow.DATA) {
                            widget.currentRow[TABS[table].DTINC] = datas[dt].DTINC;
                            widget.currentRow[TABS[table].DTULTA] = datas[dt].DTULTA;
                            widget.currentRow.NRORGINCLUSAO = datas[dt].NRORGINCLUSAO;
                            widget.currentRow.CDOPERINCLUSAO = datas[dt].CDOPERINCLUSAO;
                            widget.currentRow.NRORGULTATU = datas[dt].NRORGULTATU;
                            widget.currentRow.IDATIVO = datas[dt].IDATIVO;
                        }
                    }
                    widget.currentRow.__is_new = widget.currentRow.__is_new ? true : false;
                    widget.currentRow.CDFILIAL = CDFILIAL;
                    widget.currentRow.NRORG = NRORG;
                    widget.currentRow.TABS = TABS;
                    widget.currentRow[TABS[table].DTFERI] = moment(widget.currentRow.DATA, 'YYYY-MM-DD').format('DD/MM/YYYY');
                    widget.currentRow[TABS[table].DSFERI] = widget.currentRow.DESC;
                    dataset.push(angular.copy(widget.currentRow));
                }
                promise = CalendarService.saveCalendario(dataset);
            } else {
                dataset = [];
                for (var dta in datas) {
                    if (datas[dta].DATE == widget.currentRow.DATA) {
                        widget.currentRow[TABS[tabCal].DTINC] = datas[dta].DTINC;
                        widget.currentRow[TABS[tabCal].DTULTA] = datas[dta].DTULTA;
                        widget.currentRow.NRORGINCLUSAO = datas[dta].NRORGINCLUSAO;
                        widget.currentRow.CDOPERINCLUSAO = datas[dta].CDOPERINCLUSAO;
                        widget.currentRow.NRORGULTATU = datas[dta].NRORGULTATU;
                        widget.currentRow.IDATIVO = datas[dta].IDATIVO;
                    }
                }
                widget.currentRow.CALENDAR = tabCal;
                widget.currentRow.__is_new = widget.currentRow.__is_new ? true : false;
                widget.currentRow.CDFILIAL = CDFILIAL;
                widget.currentRow.NRORG = NRORG;
                widget.currentRow.TABS = TABS;
                widget.currentRow[TABS[tabCal].DTFERI] = moment(widget.currentRow.DATA, 'YYYY-MM-DD').format('DD/MM/YYYY');
                widget.currentRow[TABS[tabCal].DSFERI] = widget.currentRow.DESC;
                dataset.push(angular.copy(widget.currentRow));
                promise = CalendarService.saveCalendario(dataset);
            }
        }
        
        promise.then(function(){
            MessageService.successNotificationByCode('successOperation');
            carregaCalendario(widget);
            ScreenService.closeSwipe().then(function() {
                self.resetWidget(mainWidget);    
            });
        }.bind(this), function(callback) {
            MessageService.showMessageByCode('erroSalvarDia', null, Constants.errorMessage);
        });
        
    };
    
    this.setDefaultValue = function(widget){
        widget.applyDefaultValue();

        widget.currentRow.CDFILIAL = widget.container.getWidget('stripePopup').currentRow.CDFILIAL;
        widget.currentRow.NMFILIAL = widget.container.getWidget('stripePopup').currentRow.NMFILIAL;
        
        if((widget.name == "exportar") || (widget.name == "calCalendCompras" )) {
            widget.currentRow.ANO = widget.container.getWidget('stripePopup').currentRow.ANO;
        }
    };
    
    this.setDtSource = function(field) {
        field.dataSourceFilter = [
            {
                "name": "P_CDOPERADOR", 
                "operator": "=", 
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILIAL",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        
        field.initializeField();
    };
    
    this.autoOperation = function(widget, operation) {
        var diaWidget = widget.parent.parent.container.getWidget('dia');
        var calendarWidget = widget.parent.parent;
        var diaInicial = moment(widget.currentRow.start, 'DD/MM/YYYY');
        var diaFinal = moment(widget.currentRow.end, 'DD/MM/YYYY');
        var dias = [];
        var weekday;
        
        if(diaFinal.isAfter(diaInicial) || diaFinal.isSame(diaInicial)){
            while (diaInicial <= diaFinal) {
                weekday = diaInicial.format('d');
                if (widget.currentRow.weekdays.indexOf(weekday) >= 0) {
                    dias.push(diaInicial.format('YYYY/MM/DD'));
                }
                diaInicial.add(1, 'day');
            }
            if (operation == 1) {
                calendarWidget.currentRow = dias;
                if (widget.currentRow.calendario == "filial") {
                    this.verificaDia(calendarWidget).then(function(diasFilial) {
                        if (diasFilial) {
                            calendarWidget.currentRow = diasFilial;
                            calendarWidget.currentRow = dias;
                            salvar(calendarWidget, true, ["filial", "compras", "bancario", "cardapio"]).finally(function() {
                                carregaCalendario(widget);
                                MessageService.successNotificationByCode('successOperation');
                                ScreenService.closeSwipe();
                                calendarWidget.activate();
                            }.bind(this));
                        } else {
                            ScreenService.closeSwipe();
                            calendarWidget.activate();
                        }
                    }.bind(this));
                } else {
                    salvar(calendarWidget, true, widget.currentRow.calendario).then(function(){
                        carregaCalendario(widget);
                        MessageService.successNotificationByCode('successOperation');
                        calendarWidget.activate();
                    }.bind(this),function(callback){
                        MessageService.showMessageByCode('erroCadastramento', null, Constants.errorMessage);
                    });
                }
            } else if (operation == 2) {
                diaWidget.currentRow = dias;
                this.excluirDiaNaoUtil(diaWidget);
            }
        } else {
            MessageService.showMessageByCode("dataInicial", null, Constants.infoMessage);
        }
    };
    
    this.detalhes = function(widget){
        openDetails(widget);
    };
    
    function openDetails(widget) {
        var diaWidget = widget.container.getWidget('dia');
        
        let stripeWidget = templateManager.container.getWidget('stripeWidget');
        diaWidget.currentRow.CDFILIAL = angular.copy(stripeWidget.currentRow.CDFILIAL);
        
        var tabbedDiaWidget = widget.container.getWidget('tabbedDia');
        var diaAtual;
        var dias = widget.dataSource.data;
        for (var dia in dias) {
            if (dias[dia].DATE == widget.currentRow) {
                diaAtual = dias[dia];
            }
        }
        if (diaAtual) {
            diaWidget.currentRow = {
                DESC: diaAtual.TITLE,
                DATA: diaAtual.DATE
            };
            diaWidget.label = moment(widget.currentRow).format('DD/MM/YYYY');
            diaWidget.view();
            diaWidget.template = diaWidget.formTemplate = diaWidget.templateToView;
            ScreenService.openSwipe(tabbedDiaWidget);
            diaWidget.activate();
        } else {
            diaWidget.label = moment(widget.currentRow).format('DD/MM/YYYY');
            diaWidget.newRow();
            diaWidget.currentRow.DATA = widget.currentRow;
            diaWidget.template = diaWidget.formTemplate = diaWidget.templateToForm;
            ScreenService.openSwipe(tabbedDiaWidget);
            diaWidget.activate();
        }
    }
    
    this.openReport = function(widget, args){
        if(widget.isValid() && isValidDate(widget)) {
            var reportName;
            switch (widget.currentRow.calendario) {
                case 'filial':
                    reportName = 'ger02400';
                break;
                case 'compras':
                    reportName = 'ger02401';
                break;
                case 'bancario':
                    reportName = 'ger02402';
                break;
                case 'cardapio':
                    reportName = 'ger02406';
                break;
            }

            General.openReportPopup(widget, this.abreRelatorio, [widget, args, reportName]);
                var reportWid = templateManager.container.getActiveWidget();
                reportWid.fields[0].dataSource.data[2].name = 'txt';
                reportWid.fields[0].dataSource.data[2].value = 'TXT';
                delete reportWid.fields[0].dataSource.data[3];
                reportWid.fields[0].dataSource.data.length = 3;
                
            
        }
    };
    
    function isValidDate(widget){
        var dtIni = angular.copy(widget.currentRow.DTINICIAL);
        var dtFim = angular.copy(widget.currentRow.DTFINAL);
        
        dtIni = moment(dtIni, 'MM/YYYY');
        dtFim = moment(dtFim, 'MM/YYYY');
        
        if(dtIni.isAfter(dtFim)){
            MessageService.showMessageByCode("mesInicial", null, Constants.infoMessage);
            return false;
        } else {
            return true;
        }
    }
    
    this.abreRelatorio = function(widget, args, reportName) {
        var row = angular.copy(args.row);
        
        if(row.CDGRUPFILI){
            row.CDGRUPFILI = row.CDGRUPFILI;
            row.LCDGRUPFILI = row.CDGRUPFILI;
        }else{
            row.CDGRUPFILI = null;
            row.LCDGRUPFILI = 'T';
        }
        row.DTINICIAL = moment(row.DTINICIAL, 'MM/YYYY').startOf('month').format('DD/MM/YYYY');
        row.DTFINAL = moment(row.DTFINAL, 'MM/YYYY').endOf('month').format('DD/MM/YYYY');
        row.CDFILIAL = row.CDFILIALDESTINO ? row.CDFILIALDESTINO.join('_') : 'T';
        General.openReport('cadSup#/relatorioCalendario', reportName, row);
    };
    
    this.onEnterRelatorio = function(widget){
        widget.applyDefaultValue();
    };
    
    function showGenericError(error){
        let errorMessage = "TIMEOUT";
        let textContentError = '';
        
        if (error.data){
            errorMessage = "ERR_GENERICO";
            textContentError = error.data.error;
        }
        MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError}, Constants.errorMessage);
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger02400_Dias_Nao_Uteis_Controller', Ger02400_Dias_Nao_Uteis_Controller);
}); 

// FILE: ./assets/js/controllers/ger07100_tipo_de_fornecedorController.js
var ger07100_tipo_de_fornecedorController = function (ScreenService, MessageService, General, templateManager){
    
    
    this.new = function(widget) {
        widget.newRow();
        General.justInteger('#CDTIPOFORN');
        
        widget.currentRow.__is_new = true;
        
        widget.getField('CDTIPOFORN').readOnly = false;
        widget.getField('NMTIPOFORN').readOnly = false;
    };
    
    this.edit = function(widget){
        widget.getField('CDTIPOFORN').readOnly = true;
        General.widgetEdit(widget);
    };
    
    this.backSwipe = function(args){
    	args.owner.widget.currentRow = {};
    	ScreenService.closePopup();
    	args.owner.widget.getParent().reload();
    };
    
    this.insertFornecedor = function(widget) {
        if(!widget.currentRow.__is_new){
            updateFornecedor(widget);
            return;
        }
        
        widget.currentRow.CDTIPOFORN = ("000" + widget.currentRow.CDTIPOFORN).slice(-3);
        
        if(widget.isValid()) {
           General.callRestEngine('cadSup#/ger07100Controller/insertFornecedor','Row', widget.currentRow).then(function(res){
        	   widget.currentRow = {};
        	   MessageService.successNotificationByCode('saveSucess');
        	   
        	   ScreenService.closeSwipe();
        	   widget.reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
            
        }
    };
    
    const updateFornecedor = function(widget) {
        if(widget.isValid()) {
            
            var row = {
                CDTIPOFORN: widget.currentRow.CDTIPOFORN,
                NMTIPOFORN: widget.currentRow.NMTIPOFORN,
                OLD_CDTIPOFORN: widget.backupRow.CDTIPOFORN,
                OLD_NMTIPOFORN: widget.backupRow.NMTIPOFORN
            };
            
           General.callRestEngine('cadSup#/ger07100Controller/updateFornecedor','Row', row).then(function(res){
        	   widget.reload();
               widget.view();
        	   MessageService.successNotificationByCode('saveSucess');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
            
        }
    };
    
     this.deleteFornecedor = function(widget) {
        MessageService.confirmMessageByCode("excluirRegistro", null , Constants.confirmationMessage).then(function(){
        	
        	General.callRestEngine('cadSup#/ger07100Controller/deleteFornecedor','Row', widget.currentRow).then(function(res){
        	       ScreenService.closeSwipe();
        	       widget.reload();
        	       MessageService.successNotificationByCode('excluidoSucces');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.cancel = function(widget) {
        widget.getField('CDTIPOFORN').readOnly = false;
    	General.widgetCancelForm(widget);
    };
    
    this.enter = function(widget) {
        General.justInteger("#CDTIPOFORN");
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('ger07100_tipo_de_fornecedorController', ger07100_tipo_de_fornecedorController);
});

// FILE: ./assets/js/controllers/Ger41400_grupo_de_fornecedorController.js
var Ger41400_grupo_de_fornecedorController = function (ScreenService, MessageService, General){
    
    
    this.new = function(widget) {
        widget.newRow();
        General.justInteger('#CDGRUPFORN');
        
        widget.currentRow.__is_new = true;
        
        widget.getField('CDGRUPFORN').readOnly = false;
        widget.getField('NMGRUPFORN').readOnly = false;
    
    };
    
    this.edit = function(widget){
        widget.getField('CDGRUPFORN').readOnly = true;
        General.widgetEdit(widget);
    };
    
    this.backSwipe = function(args){
    	args.owner.widget.currentRow = {};
    	ScreenService.closePopup();
    	args.owner.widget.getParent().reload();
    };
    
    this.insertFornecedor = function(widget) {
        if(!widget.currentRow.__is_new){
            updateFornecedor(widget);
            return;
        }
        
        if(widget.isValid()) {
            
           General.callRestEngine('cadSup#/Ger41400Controller/insertFornecedor','Row', widget.currentRow).then(function(res){
        	   widget.currentRow = {};
        	   MessageService.successNotificationByCode('saveSucess');
        	   
        	   ScreenService.closeSwipe();
        	   widget.reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
            
        }
    };
    
    const updateFornecedor = function(widget) {
        if(widget.isValid()) {
            
            var row = {
                CDGRUPFORN: widget.currentRow.CDGRUPFORN,
                NMGRUPFORN: widget.currentRow.NMGRUPFORN,
                OLD_CDGRUPFORN: widget.backupRow.CDGRUPFORN,
                OLD_NMGRUPFORN: widget.backupRow.NMGRUPFORN
            };
            
           General.callRestEngine('cadSup#/Ger41400Controller/updateFornecedor','Row', row).then(function(res){
        	   widget.reload();
               widget.view();
        	   MessageService.successNotificationByCode('saveSucess');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
            
        }
    };
    
     this.deleteFornecedor = function(widget) {
        MessageService.confirmMessageByCode("excluirRegistro", null , Constants.confirmationMessage).then(function(){
        	
        	General.callRestEngine('cadSup#/Ger41400Controller/deleteFornecedor','Row', widget.currentRow).then(function(res){
        	       ScreenService.closeSwipe();
        	       widget.reload();
        	       MessageService.successNotificationByCode('excluidoSucces');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.cancel = function(widget) {
        widget.getField('CDGRUPFORN').readOnly = false;
    	General.widgetCancelForm(widget);
    };
    
    this.enter = function(widget) {
        General.justInteger("#CDGRUPFORN");
    };
};

Configuration(function (ContextRegister){
    ContextRegister.register('Ger41400_grupo_de_fornecedorController', Ger41400_grupo_de_fornecedorController);
});

// FILE: ./assets/js/controllers/mensagens_envio_emailController.js
function mensagens_envio_emailController(ScreenService, General, localStorageEngine,MessageService,restEngine, templateManager) {
    
    let mensagens_envioAddOrEdit = 0;
    
    var self = this;
    
    this.editar = function(widget) {
        
       mensagens_envioAddOrEdit = 2;
        
       const mainWid =  widget.container.getWidget('MainWidget');

        mainWid.getField('IDOPERACAO').readOnly = true;
        mainWid.getField('DSSUBJECT').readOnly = false;
        
        mainWid.getField('DSBODY').isVisible = false;

        mainWid.getField('DSBODY2').isVisible = true;
        
        
        General.edit(mainWid);
    };
    
    this.backEdit = function(args){
        const mainWid =  args.owner.widget.container.getWidget('MainWidget');
        mainWid.getField('IDOPERACAO').readOnly = false;
        mainWid.getField('DSSUBJECT').readOnly = true;

        
        mainWid.getField('DSBODY').isVisible = true;

        mainWid.getField('DSBODY2').isVisible = false;
        
        //General.backOrCancel(mainWid);
        mainWid.reload();
        mainWid.list();
        self.getData(args.owner.widget);
        };
    
    this.excluir = function(widget) {
        
       const mainWid =  widget.container.getWidget('MainWidget');
       let row = mainWid.currentRow;
        General.callRestEngine('cadSup#/deleteMsgEnvEmail', 'Row', row).then(function(success) {
           self.getData(widget);
          //self.getData(widget);
          //widget.reload();
          }, function(error) {
              var errorMessage = "Timeout";
              let textContentError = '';
              if (error.data){
                  errorMessage = "ERR_GENERICO";
                  textContentError = error.data.error;
              }
              MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
            }
        );
       
       
        
    };
    
    this.adicionar = function(widget) {
        mensagens_envioAddOrEdit = 1;
        
       const mainWid =  widget.container.getWidget('MainWidget');

        mainWid.getField('IDOPERACAO').readOnly = true;
        mainWid.getField('DSSUBJECT').readOnly = false;

        
        mainWid.getField('DSBODY').isVisible = false;

        mainWid.getField('DSBODY2').isVisible = true;
        
        General.edit(mainWid);
        
        
         
    };
    
    //Mesmo método para salvar ou adicionar uma mensagem
    this.saveRow = function(args) {
        // Se é para add mensagens_envioAddOrEdit = 1
        const mainWid =  args.owner.widget.container.getWidget('MainWidget');
       
       if(mainWid.isValid){
           if(mensagens_envioAddOrEdit == 1){
               //add uma nova msg
               let row = {};
               row.DSSUBJECT = mainWid.currentRow.DSSUBJECT;
                row.DSBODY = mainWid.currentRow.DSBODY2;
                 row.IDOPERACAO = mainWid.currentRow.IDOPERACAO;
               
               General.callRestEngine('cadSup#/createNewMsgEnvEmail', 'Row', row).then(function(success) {
                   self.backEdit(args);
                  //self.getData(widget);
                  //widget.reload();
                  }, function(error) {
                      var errorMessage = "Timeout";
                      let textContentError = '';
                      if (error.data){
                          errorMessage = "ERR_GENERICO";
                          textContentError = error.data.error;
                      }
                      MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
                    }
                  );
               
               
               
           }else if (mensagens_envioAddOrEdit == 2){
               //editar campos
               let row = mainWid.currentRow;
                row.DSBODY = mainWid.currentRow.DSBODY2;
                General.callRestEngine('cadSup#/atualizaMsgEnvEmail', 'Row', row).then(function(success) {
                   self.backEdit(args);
                  //self.getData(widget);
                  //widget.reload();
                  }, function(error) {
                      var errorMessage = "Timeout";
                      let textContentError = '';
                      if (error.data){
                          errorMessage = "ERR_GENERICO";
                          textContentError = error.data.error;
                      }
                      MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
                    }
                );
           }
           
       }
         
    };
    
     this.getData = function(widget) {
      const mainWid =  widget.container.getWidget('MainWidget');
      const stripe =  widget.container.getWidget('stripe');
      
      let rowIDOPER = mainWid.currentRow.IDOPERACAO;
      
      
      General.callRestEngine('cadSup#/crud/mensagensenvio', 'FilterData', [
          {
              "name": "IDOPERACAO",
              "operator": "=",
              "value": rowIDOPER
          },
          {
              "name": "IDATIVO",
              "operator": "=",
              "value": "S"
          }
      ]).then(function(success) {
        if(success.dataset.mensagensenvio.length != 0){
            //edit ou delete
          let row = {};
          let respMsgenvio = success.dataset.mensagensenvio[0];
          row.DSSUBJECT = respMsgenvio.DSSUBJECT;
          row.DSBODY = respMsgenvio.DSBODY;
          row.IDOPERACAO = respMsgenvio.IDOPERACAO;
          row.DSBODY2 = respMsgenvio.DSBODY;
          
          mainWid.currentRow = row;
          
          stripe.getAction('editar').isVisible = true;
          stripe.getAction('delete').isVisible = true;
          stripe.getAction('add').isVisible = false;
        }else{
            //se cair aqui é pq é pra add
          if(rowIDOPER != null){
              let row = {};
              row.DSSUBJECT = '';
              row.DSBODY = '';
              row.DSBODY2 = '';
              row.IDOPERACAO = rowIDOPER;
              
              mainWid.currentRow = row;
              
              stripe.getAction('editar').isVisible = false;
              stripe.getAction('delete').isVisible = false;
              stripe.getAction('add').isVisible = true;
          }else{
              let row = {};
              row.DSSUBJECT = '';
              row.DSBODY = '';
              row.DSBODY2 = '';
              row.IDOPERACAO = '';
              
              mainWid.currentRow = row;
              
              stripe.getAction('editar').isVisible = false;
              stripe.getAction('delete').isVisible = false;
              stripe.getAction('add').isVisible = false;
          }
        }
      },function(error) {
          var errorMessage = "Timeout";
          let textContentError = '';
          if (error.data){
              errorMessage = "ERR_GENERICO";
              textContentError = error.data.error;
          }
          MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
        }
      );
   
  };
    
    this.cancelar = function(widget) {
        ScreenService.openWindow('sup_cotacao#sup54680_pedido_de_coleta');
    };
    
    this.selectExtensao = function(widget) {
        ScreenService.openPopup(widget.container.getWidget('extensoes'));
    };
    
    this.enviar = function(widget) {
        alert("OK!");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('mensagens_envio_emailController', mensagens_envio_emailController);
});

// FILE: ./assets/js/controllers/RegiaoController.js
function RegiaoController(ScreenService, MessageService, templateManager, General, maskEngine,ZHPromise) {
    var self = this;
    
    this.abrirFornecedor = function(widget, id){
        if(id == 1){
		    const atende = widget.container.getWidget('fornecedorAtende');
		    
		    atende.widgetOrigin = widget;
            atende.newRow();
    	    ScreenService.openPopup(atende);
		    atende.activate();
		    atende.reload();
        }
        else if(id == 2){
            const naoatende = widget.container.getWidget('fornecedorNaoAtende');

            naoatende.widgetOrigin = widget;
            naoatende.newRow();
    	    ScreenService.openPopup(naoatende);
		    naoatende.activate();
		    naoatende.reload();    
        }
	};
	
	this.setRegiao = function(field){
	    field.dataSourceFilter = [
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILIAL",
                        "direction": "ASC"
                    }    
                ]
            },
            {
            	"name": "P_CDREGIAO",
                "operator": "=",
                "value": field.widget.getParent().currentRow.CDREGIAO 
            }
        ];
        field.reload();
	};
	
    this.changeValidation = function(field){
		if(field.checked) {
			field.widget.getField(field.name.substring(2,field.name.length)).clearValue();
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = true;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = {};
		} else {
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = false;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = { "required": {} };
		}
    };
	
    this.cadastroAutomaticoFornecedorAtende = function(widget){
        if (widget.isValid()) {
            
            if (widget.currentRow.NMREGIAO == "" && widget.currentRow.NMFANTFORN == "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function () {
                        widget.currentRow.T_NMREGIAO = 'T';
                        widget.currentRow.T_NMFANTFORN = 'T';
                        self.saveFornecedorAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoRegiaoeForneced", null, config);
                
            } else if(widget.currentRow.NMREGIAO == "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function () {
                        widget.currentRow.T_NMREGIAO = 'T';
                        self.saveFornecedorAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoTodasRegioes", null, config);
                
            } else if(widget.currentRow.NMFANTFORN == "" ) {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function () {
                        widget.currentRow.T_NMFANTFORN = 'T';
                        self.saveFornecedorAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoTodasForneced", null, config);
                
            } else if(widget.currentRow.NMREGIAO != "" && widget.currentRow.NMFANTFORN != "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function (success) {
                        self.saveFornecedorAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("realizarCadastro", null, config);
            }
        }
    };
        
    this.cadastroAutomaticoFornecedorNaoAtende = function(widget){
        if (widget.isValid()) {
            
            if (widget.currentRow.NMREGIAO == "" && widget.currentRow.NMFANTFORN == "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function(){
                        widget.currentRow.T_NMREGIAO = 'T';
                        widget.currentRow.T_NMFANTFORN = 'T';
                        self.saveFornecedorNaoAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoRegiaoeForneced", null, config);
                
            } else if(widget.currentRow.NMREGIAO == "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function(){
                        widget.currentRow.T_NMREGIAO = 'T';
                        self.saveFornecedorNaoAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoTodasRegioes", null, config);
                
            } else if(widget.currentRow.NMFANTFORN == "" ) {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function () {
                        widget.currentRow.T_NMFANTFORN = 'T';
                        self.saveFornecedorNaoAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("confirmarCadastramentoTodasForneced", null, config);
                
            } else if(widget.currentRow.NMREGIAO != "" && widget.currentRow.NMFANTFORN != "") {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function (success) {
                        self.saveFornecedorNaoAtende(widget);
                    }
                };
                MessageService.confirmMessageByCode("realizarCadastro", null, config);
            }
        }
    };
    
    this.saveFornecedorAtende = function(widget){
        let fornAtende = widget.container.getWidget("fornecedorAtende");
        const widgetOrigin = fornAtende.widgetOrigin;
        
        if (widget.currentRow.T_NMREGIAO == 'T') {
            widget.currentRow.REGIAO = null;    
        } else {
            widget.currentRow.REGIAO = widget.currentRow.CDREGIAO.join('_');
        }
        
        if (widget.currentRow.T_NMFANTFORN == 'T') {
            widget.currentRow.FORNECED = null;    
        } else {
            widget.currentRow.FORNECED = widget.currentRow.CDFORNECED.join('_');
        }
        
        General.callRestEngine('cadSup#/regiaoController/delete', 'Row', widget.currentRow).then(function(callback) {
            widget.container.getWidget('fornecedornaoatende_table').reload();
            MessageService.notificationMessageByCode("cadastradoSucces", null, Constants.successNotification).then(function(){
                fornAtende.getField("NMREGIAO").readOnly = false;
                fornAtende.getField("NMFANTFORN").readOnly = false;
                fornAtende.currentRow.T_NMREGIAO = "";
                fornAtende.currentRow.T_NMFANTFORN = "";
                ScreenService.closePopup();
                ScreenService.closePopup();
                widgetOrigin.activate();
            });
	    }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.saveFornecedorNaoAtende = function(widget){
        let fornecedorNaoAtende = widget.container.getWidget("fornecedorNaoAtende");
        let modalError = widget.container.getWidget('popupErro');
        const widgetOrigin = fornecedorNaoAtende.widgetOrigin;
            
        if (widget.currentRow.T_NMREGIAO == 'T') {
            widget.currentRow.REGIAO = null;    
        } else {
            widget.currentRow.REGIAO = widget.currentRow.CDREGIAO.join('_');
        }
        
        if (widget.currentRow.T_NMFANTFORN == 'T') {
            widget.currentRow.FORNECED = null;    
        } else {
            widget.currentRow.FORNECED = widget.currentRow.CDFORNECED.join('_');
        }
        
        General.callRestEngine('cadSup#/regiaoController/insert', 'Row', widget.currentRow).then(function(callback) {
            if (callback.length === undefined) {
                MessageService.showMessageByCode('operacaoBloqueada', null, Constants.errorMessage).then(function(){
					modalError.dataSource.data = callback.dataset.columnsToReturn[0];
                    ScreenService.openPopup(modalError);
				});
            } else {
                MessageService.notificationMessageByCode("cadastradoSucces", null, Constants.successNotification).then(function(){
                    widget.container.getWidget('fornecedornaoatende_table').reload();
                    fornecedorNaoAtende.getField("NMREGIAO").readOnly = false;
                    fornecedorNaoAtende.getField("NMFANTFORN").readOnly = false;
                    fornecedorNaoAtende.currentRow.T_NMREGIAO = "";
                    fornecedorNaoAtende.currentRow.T_NMFANTFORN = "";
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    widgetOrigin.activate();    
                });
            }
        }, function(err){
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.changeStateSelectAccessibility = function(Accessibility) {
         templateManager.container.getWidget('regiao_table').fields[3].readOnly = Accessibility;
    };
    
    this.stateValidation = function(widget){
        widget.currentRow.NMESTADO = "";
        
        if(widget.currentRow.CDPAIS !== ""){
            widget.getField('NMESTADO').readOnly = false;
        } else {
            widget.getField('NMESTADO').readOnly = true;
            widget.currentRow.NMESTADO = "";
        }
        
        widget.getField('NMESTADO').dataSourceFilter = [
            {
                "name": "CDPAIS",
                "operator": "=",
                "value": widget.currentRow.CDPAIS
            },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMESTADO",
                        "direction": "ASC"
                    }
                ]
            }
        ];
    };
    
    this.filterByRegiao = function() {
        var currentRegiao = templateManager.container.getWidget('regiao_table').currentRow.CDREGIAO;
        var filter = [
                    {
                        "name": "CDREGIAO",
                        "operator": "=",
                        "value": currentRegiao
                    }
            ];
            this.filterFilialByRegiao(filter);
            this.filterVendedorNaoAtendeByRegiao(filter);
            this.filterMunicipioByRegiao(filter);
    };
    
    this.filterFilialByRegiao = function (filterArray) {
            filterArray = filterArray || [{
                        "name": "CDREGIAO",
                        "operator": "=",
                        "value": templateManager.container.getWidget('regiao_table').currentRow.CDREGIAO
                    }];
            var filialPorRegiaoTable = templateManager.container.getWidget('filialPorRegiao_table');
            filialPorRegiaoTable.dataSourceFilter = filterArray;
            filialPorRegiaoTable.reload();
    };
    
    this.filterVendedorNaoAtendeByRegiao = function (filterArray) {
        filterArray = filterArray || [
                    {
                        "name": "CDREGIAO",
                        "operator": "=",
                        "value": templateManager.container.getWidget('regiao_table').currentRow.CDREGIAO
                    }
            ];
        var fornecedorNaoAtendeTable = templateManager.container.getWidget('fornecedornaoatende_table');
        fornecedorNaoAtendeTable.dataSourceFilter = filterArray;
        fornecedorNaoAtendeTable.reload();
    };
    
    this.filterMunicipioByRegiao = function (filterArray) {
        filterArray = filterArray || [
                    {
                        "name": "CDREGIAO",
                        "operator": "=",
                        "value": templateManager.container.getWidget('regiao_table').currentRow.CDREGIAO
                    }
            ];
        var municipioTable = templateManager.container.getWidget('municipio_table');
        municipioTable.dataSourceFilter = filterArray;
        municipioTable.reload();
    };
    
    this.filterMunicipioPickerByRegiao = function (widget) {
        var currentRow = templateManager.container.getWidget('regiao_table').currentRow;
        widget.dataSourceFilter = [
                    {
                        "name": "P_SGESTADO",
                        "operator": "=",
                        "value": currentRow.SGESTADO
                    },
                    {
                        "name": "P_CDPAIS",
                        "operator": "=",
                        "value": currentRow.CDPAIS
                    },
                    {
                        "name": "P_CDREGIAO",
                        "operator": "=",
                        "value": currentRow.CDREGIAO
                    },
                    {
                        "name": "P_CDMUNICIPIO",
                        "operator": "=",
                        "value": "T"
                    }
        ];
        widget.reload();
    };
    
    this.setDsFilterMunicipio = function (field) {
        var currentRow = templateManager.container.getWidget('regiao_table').currentRow;
        field.dataSourceFilter = [
                    {
                        "name": "P_SGESTADO",
                        "operator": "=",
                        "value": currentRow.SGESTADO
                    },
                    {
                        "name": "P_CDPAIS",
                        "operator": "=",
                        "value": currentRow.CDPAIS
                    },
                    {
                        "name": "P_CDREGIAO",
                        "operator": "=",
                        "value": "T"
                    },
                    {
                        "name": "P_CDMUNICIPIO",
                        "operator": "=",
                        "value": "T"
                    }
        ];
    };
    
    this.cancel = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
        widget.reload();
    };
    
    this.cancelEdit = function(widget) {
        General.widgetCancelForm(widget);
        this.changeStateSelectAccessibility(true);
        widget.container.getWidget('filialPorRegiao_table').enabled = true;
		widget.container.getWidget('fornecedornaoatende_table').enabled = true;
		widget.container.getWidget('municipio_table').enabled = true;
    };
    
    this.startEdit = function (widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		widget.container.getWidget('filialPorRegiao_table').enabled = false;
		widget.container.getWidget('fornecedornaoatende_table').enabled = false;
		widget.container.getWidget('municipio_table').enabled = false;
		widget.backupRow = Util.clone(widget.currentRow, ignoredKeys);
		widget.edit();
    };
    
    this.backView = function() {
        ScreenService.closeSwipe();
        templateManager.container.getWidget('regiao_table').reload();
    };
    
    this.newRow = function(widget) {
        widget.newRow();
        if(widget.template === 'widget/grid.html'){
            widget.currentRow.__is_new = true;
            ScreenService.openSwipe(widget);
        }
    };
    
    this.saveFilialPorRegiao = function(widget) {
        if(widget.isValid()){
            
            widget.currentRow.__is_new = false;
            widget.currentRow.CDREGIAO = widget.getParent().currentRow.CDREGIAO;
            widget.currentRow.TCDREGIAO = 'T';
            
            General.callRestEngine('cadSup#/regiaoController/verificaFilial', 'Row', widget.currentRow).then(function(callback) {
                var regiao = callback.dataset.resp[0];
                if(!regiao[0].CDREGIAO) {
                    General.saveCrud(widget).then(function(){
                        ScreenService.closeSwipe();
                        widget.reload();
                        MessageService.notificationMessageByCode("saveSucess", null, Constants.successNotification).then(function(){
                            MessageService.showMessageByCode("fornecedorNaoAtendeMsg", null, Constants.alertMessage).then(function(){
                                widget.list(true);    
                            });
                        });
                    }, function(err){
                        ScreenService.showMessage(err);
                    });
                } else {
                    MessageService.showMessageByCode("impossivelAdicionarUnidade", null, Constants.errorMessage);
                }
            });     
        }
    };
    
    this.saveVendedorNaoAtende = function(widget) {
        if(widget.isValid()){
            widget.currentRow.CDREGIAO = widget.getParent().currentRow.CDREGIAO;
            General.saveCrud(widget).then(function(success){
                MessageService.notificationMessageByCode("saveSucess", null, Constants.successNotification);
            }, function(err){
                MessageService.showMessageByCode(err, null, Constants.errorMessage);
            });
        }
    };
    
    this.deleteRegiao = function(widget) {
        var deferred = ZHPromise.defer();
        
        let config = {
            type: "question",
            icon: "question",
            success: function(){
                General.callRestEngine('cadSup#/regiaoController/deleteRegiao', 'Row', widget.currentRow).then(function(success) {
                    MessageService.notificationMessageByCode("excluidoSucces", null, Constants.successNotification).then(function(){
                        ScreenService.closeSwipe();
                        widget.reload();
                    });
                }, function (error) {
    				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
    				    MessageService.showMessageByCode("exclusaoNaoPermitida", null, Constants.errorMessage);
    				} else {
    				    ScreenService.showMessage(error.data.error);
    				}
    				deferred.reject();
    			});
            }
        };
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, config);
    };
    
    this.deleteFilialPorRegiao = function(widget) {
        var deferred = ZHPromise.defer();
        
        let config = {
            type: "question",
            icon: "question",
            success: function(success){
                widget.removeRow().then(function () {
                    MessageService.notificationMessageByCode("excluidoSucces", null, Constants.successNotification).then(function(){
                        ScreenService.closeSwipe().then(function () {
        					widget.activate();
        					deferred.resolve();
        				});
                    });
    			}, function (error) {
    				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
    				    MessageService.showMessageByCode("exclusaoNaoPermitida", null, Constants.errorMessage);
    				} else {
    					ScreenService.showMessage(error.data.error);
    				}
    				deferred.reject();
    			});
             }
        };
        MessageService.confirmMessageByCode("excluiUnidade", null, config);
        
		return deferred.promise;
    };
    
    this.saveMunicipio = function(widget) {
        if(widget.isValid()){
            
            widget.currentRow.CDREGIAO = widget.getParent().currentRow.CDREGIAO;
            widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
            widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO;
            widget.currentRow.NRORG = widget.getParent().currentRow.NRORG;
            
            General.callRestEngine('cadSup#/regiaoController/insertMunicipio', 'Row', widget.currentRow).then(function(success) {
                MessageService.notificationMessageByCode("saveSucess", null, Constants.successNotification).then(function(){     
                    widget.view();
                });
            }, function(err){
                ScreenService.showMessage(err.data.error);
            });
        }
    };
   
    this.saveRegiao = function(widget) {
        if(widget.isValid()){
            var deferred = ZHPromise.defer();
            widget.saveRow().then(function(success){
				if (!widget.currentRow.__is_new) {
					widget.computeDescriptionOrder();
					deferred.resolve(success);
				}
				MessageService.notificationMessageByCode("saveSucess", null, Constants.successNotification).then(function(){
				    widget.container.getWidget('filialPorRegiao_table').enabled = true;
            		widget.container.getWidget('fornecedornaoatende_table').enabled = true;
            		widget.container.getWidget('municipio_table').enabled = true;
                    widget.fields[3].readOnly = true;
                    widget.enabled = true;
                    templateManager.updateTemplate();
                    self.filterByRegiao();
                    widget.view();
                    widget.activate();    
				});
            },function(err){
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.saveRow = function(widget) {
        if(widget.isValid()){
            General.saveCrud(widget).then(function(){
            },
            function(err){
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.delete = function(widget) {
        var deferred = ZHPromise.defer();
        
        widget.currentRow.__is_new = false;
        
        let config = {
            type: "question",
            icon: "question",
            success: function(){
                widget.removeRow().then(function () {
    				ScreenService.closeSwipe().then(function () {
    					widget.activate();
    					deferred.resolve();
    				});
    			}, function (error) {
    				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
    				    MessageService.showMessageByCode("exclusaoNaoPermitida", null, Constants.errorMessage);
    				} else {
    					ScreenService.showMessage(error.data.error);
    				}
    				deferred.reject();
    			});
            }
        };
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, config);
        
        
        
        //General.deleteCrud(widget);
    };
    
	this.voltarCadastramento = function(widget) {
	    widget.getField("NMREGIAO").readOnly = false;
	    widget.getField("NMFANTFORN").readOnly = false;
	    widget.currentRow.T_NMREGIAO = "";
	    widget.currentRow.T_NMFANTFORN = "";
	    ScreenService.closePopup();
	    widget.getParent().activate();
	};
	
}

Configuration(function(ContextRegister) {
   ContextRegister.register('RegiaoController', RegiaoController);
});

// FILE: ./assets/js/controllers/Sup00800_Fornecedor_Controller.js
let Sup00800_Fornecedor_Controller  = function(ScreenService, DecodeValueFieldService, templateManager, General, metaDataFactory, Sup00800_Fornecedor_Service, Endereco, ZHPromise, ValidationEngine, MessageService){

    
    let self = this;
    let fornecedorOutraFilial = false;
    
    this.numRowFormPgto = 0;

    self.validaTipoDesconto = function(widget){
       if (widget.currentRow.IDTPDESCFORN == "B") {
            widget.getField('VRPEDESCFORN').validations = {
                "required":{
                   "message": "Campo obrigatório"
                },
                "max": {
                   "message":"Maximum value:", 
                    "value": 100
                }
            };
            widget.getField('DSAJUCTPAG').validations = {"required": {
               "message": "Campo obrigatório"
            }};
       } else {
            delete widget.getField('DSAJUCTPAG').validations;
            widget.getField('DSAJUCTPAG').reload();
            delete widget.getField('VRPEDESCFORN').validations;
            widget.getField('VRPEDESCFORN').reload();
            widget.getField('VRPEDESCFORN').validations = {
                "max": {
                    "message":"Maximum value:", 
                    "value": 100
                }
            };
        }
    };

    self.checkIDTPENDEFORN = function() {
        let widget = templateManager.container.getWidget("endereco");
        let atual = widget.currentRow.IDTPENDEFORN;
        let data = [];
        let i = 0;

        widget.getField('IDTPENDEFORNSELECT').dataSource.rawdata.forEach(function(fieldrow) {
            fieldrow.ENABLE = true;
            widget.dataSource.data.forEach(function(row) {
                if(row.IDTPENDEFORN == fieldrow.IDTPENDEFORN){
                    fieldrow.ENABLE = false;
                }
            });
            if(fieldrow.ENABLE) data[i++] = fieldrow;
        });

        widget.getField('IDTPENDEFORNSELECT').dataSource.data = (widget.currentRow.__is_new)? data : widget.getField('IDTPENDEFORNSELECT').dataSource.rawdata;
        widget.currentRow.IDTPENDEFORN = (widget.currentRow.__is_new)? (data[0]? data[0].IDTPENDEFORN : null) : widget.currentRow.IDTPENDEFORN;
        widget.currentRow.IDTPENDEFORNSELECT = widget.currentRow.IDTPENDEFORN;
        widget.getField('IDTPENDEFORNSELECT').reload();
    };

    self.endefornSetIDTPENDEFORN = function() {
        let widget = templateManager.container.getWidget("endereco");

        widget.currentRow.IDTPENDEFORN = widget.currentRow.IDTPENDEFORNSELECT;
    };

    self.setDocumentosFiscaisEletronicos = function(widget,visivel){
        widget.getField('DSEMAILFORNNFE').isVisible = visivel;
        widget.getField('DSEMAILFORNCTE').isVisible = visivel;
        widget.getField('DSEMAILFORNMDFE').isVisible = visivel;
        widget.getField('IDCOMPARQXMLFOR').isVisible = visivel;
    };
    
    self.endefornCheckActions = function() {
        let widget = templateManager.container.getWidget("endereco");
        let parentRow = widget.getParent().currentRow;
        
        if(widget.currentRow.__is_new) return;
        
        if(widget.currentRow.IDTPENDEFORN == 'P') 
        {
            widget.getAction('DELETE').isVisible = false;
            widget.getAction('COPY').isVisible = true;
            self.setDocumentosFiscaisEletronicos(widget,true);
        }
        else {
            widget.getAction('DELETE').isVisible = true;
            widget.getAction('COPY').isVisible = false;
            self.setDocumentosFiscaisEletronicos(widget,false);
        }
        
        if(widget.dataSource.data.length == widget.getField('IDTPENDEFORNSELECT').dataSource.rawdata.length) widget.getAction('ADD').isVisible = false;
        else widget.getAction('ADD').isVisible = true;
        
        if(parentRow.CDFILIFORN == null && parentRow.IDFUNCAOFILI != 'F' && parentRow.FRANQUEADORA > 0) {
            widget.getAction('ADD').isVisible = false;
            widget.getAction('EDIT').isVisible = false;
            widget.getAction('DELETE').isVisible = false;
        }
        else {
            widget.getAction('EDIT').isVisible = true;
        }
        
        let wid = templateManager.container.getWidget('endereco');
        
        wid.currentRow.IDCOMPARQXMLFOR = wid.getParent().currentRow.IDCOMPARQXMLFOR;
    };
    
    function showErrorInscricao(inscricao) {
        if(inscricao.tipo.cod == 'J') 
            inscricao.tipo.msg = 'CNPJ_INVALIDO';
        else if(inscricao.tipo.cod == 'F') 
            inscricao.tipo.msg = 'CPF_INVALIDO';
        else if(inscricao.tipo.cod == 'I') 
            inscricao.tipo.msg = 'INS_INT_INVALIDA';
        
        if(inscricao.tipo.msg){
            MessageService.showMessageByCode(inscricao.tipo.msg, {"PARAMS":inscricao.value}, Constants.errorMessage);
        }
    }
    
    self.changeReadOnlyFieldsForn = function(widget, readOnly, fornecedor) {
        widget.fields.map(function(field) {
            let name = field.name;
            if(name != 'NRINSJURFORN') {
                if(name != 'IDTPIJURFORN') field.readOnly = readOnly; 
                if(fornecedor[name]) {
                    widget.currentRow[name] = fornecedor[name];
                }
            }
        });
        
        templateManager.container.getWidget('endprinc').fields.map(function(field) {
            let name = field.name;
            if(name != 'IDTPENDEFORN') {
                field.readOnly = readOnly; 
                if(fornecedor[name]) {
                    templateManager.container.getWidget('endprinc').currentRow[name] = fornecedor[name];
                }
            }
        });
        
        if(fornecedor.CDPAIS) {
            templateManager.container.getWidget('endprinc').currentRow.CDPAIS = fornecedor.CDPAIS;
        }
    };

    self.checkInscricaoContaCorrente = function(widget) {
        let inscricao = General.inscricaoFormat(widget.currentRow.NRINSCNABFOR);
        
        if(inscricao.valid) {
            widget.currentRow.NRINSCNABFOR = inscricao.value;
            widget.currentRow.IDTPICNABFOR = inscricao.tipo.cod;
        } else {
            showErrorInscricao(inscricao);
            widget.currentRow.NRINSCNABFOR = null;
        }
    };

    self.validaMascaraFieldsBanco = function(widget){
        let conta = templateManager.container.getWidget('contacorrente');
        
        conta.currentRow.CDAGENFORN = '';
        conta.currentRow.CDCCORFORN = '';
            
        let mascaraAgencia = widget.currentRow.CDPICTAGEN;
        let mascaraConta = widget.currentRow.CDPICTCONT;
        if (conta.currentRow.CDBANCFORN) {
            $('#CDAGENFORN').mask(mascaraAgencia);
            $('#CDCCORFORN').mask(mascaraConta);
            widget.getField('CDAGENFORN').maxlength = mascaraAgencia.length;
        }else{
            $('#CDAGENFORN').unmask();
            $('#CDCCORFORN').unmask();
            if(mascaraAgencia != ""){
                widget.getField('CDAGENFORN').maxlength = mascaraAgencia.replace('-','').length;
            }
        }
    };
    
    self.resetaMaxLengthAgencia = function (widget,number) {
        widget.getField('CDAGENFORN').maxlength = number;  
    };

    self.criaCdforneced = function(widget){
        if (widget.currentRow.__is_new) {
            if( widget.currentRow.NRINSJURFORN ) {
                let inscricao = widget.currentRow.NRINSJURFORN.replace(/\.|\/|\-/g, '');
                let tipoInscricao = widget.currentRow.IDTPIJURFORN;
                widget.getField('CDFORNECED').setValue(tipoInscricao + inscricao);
            } else {
                if(widget.getField('CDFORMPGTO'))
                    widget.getField('CDFORMPGTO').setValue('');
            }
        }
    };

    self.setInscricaoJuridica = function(widget) {
        widget.fields.filter(function(field) {
            if (field.id == '115003'){
                field.isVisible = 'true';
                field.showOnForm = 'true';
            }
        });
    };

    self.justInteger = function (campos){
        campos.forEach(function(campo){
            General.justInteger(campo);
        });
    };
    

    self.addFornecedor = function(){
        let fornecedorWidget = templateManager.container.getWidget("fornecedor");
        let addressWidget = templateManager.container.getWidget("endprinc");
        self.habilitaEnderecoPrincipal();
        fornecedorWidget.getField("NRINSJURFORN").readOnly = false;
        
        fornecedorWidget.newRow();
        
        fornecedorWidget.currentRow.IDTPIJURCLIE = 'J';
        
        self.checkInscricao(fornecedorWidget);
        
        addressWidget.showAsTab = true;
        addressWidget.isVisible = true;
        
        addressWidget.setCurrentRow({});
        addressWidget.edit();
        
        addressWidget.currentRow.__is_new = true;
        
        addressWidget.currentRow.IDTPENDEFORN = "P";
    };

    self.habilitaEnderecoPrincipal = function(){
        templateManager.container.getWidget("endereco").isVisible = false;
        templateManager.container.getWidget("endprinc").isVisible = true;
        templateManager.container.getWidget("endprinc").showAsTab = true;
        templateManager.container.getWidget("endprinc").enabled   = true;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("financeiro"),
            templateManager.container.getWidget("contapagar"),
            templateManager.container.getWidget("OBSERVACAO"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("contacorrente"),
            templateManager.container.getWidget("interlocutores")], false);
    };

    self.fornecedorCancelForm = function(widget) {
        let indexOfCurrentRow = null;
        let fornecedorWidget = templateManager.container.getWidget("fornecedor");
        if(fornecedorWidget.currentRow.__is_new) {
            let addressWidget = templateManager.container.getWidget("endprinc");
            
            templateManager.container.getWidget("endereco").isVisible = true;
            templateManager.container.getWidget("endprinc").isVisible = false;
            
            self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
                templateManager.container.getWidget("parametrizacao"),
                templateManager.container.getWidget("financeiro"),
                templateManager.container.getWidget("contapagar"),
                templateManager.container.getWidget("OBSERVACAO"),
                templateManager.container.getWidget("pagamento"),
                templateManager.container.getWidget("contacorrente"),
                templateManager.container.getWidget("interlocutores")], true);
            if (addressWidget.dataSource.data) {
                indexOfCurrentRow = addressWidget.dataSource.data.indexOf(addressWidget.currentRow);
                if (indexOfCurrentRow !== -1) addressWidget.dataSource.data.pop();
            }
            addressWidget.currentRow = {};
            if (fornecedorWidget.dataSource.data) {
                indexOfCurrentRow = fornecedorWidget.dataSource.data.indexOf(fornecedorWidget.currentRow);
                if (indexOfCurrentRow !== -1) fornecedorWidget.dataSource.data.pop();
            }
            fornecedorWidget.currentRow = {};
            
            addressWidget.showAsTab = false;
            addressWidget.isVisible = false;
            
            fornecedorWidget.list();
            
            ScreenService.closeSwipe();
            
            fornecedorWidget.activate();
            self.changeReadOnlyFieldsForn(fornecedorWidget, false, []);
        } else {
            self.masterDetailCancelForm(widget);
        }
    };

    self.setCdfornecedor = function (widget){
        widget.currentRow.CDFORNECED = widget.dataSourceFilter[0].value;
    };

    function onlyNumbers(text) {
        if(text) {
            return text.replace(/[^0-9]/g, '');
        } else {
            return text;
        }
    }

    self.removeCEPmask = function (endprincWidget) {
        endprincWidget.currentRow.NRCEPFORN = onlyNumbers(endprincWidget.currentRow.NRCEPFORN);
    };

    self.salvarFornecedor = function() {
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let parceiroNegocio = fornecedorWidget.currentRow.NRPARCNEGOCIO;

        if(fornecedorWidget.currentRow.NMRAZSOCFORN.length > 100) {

            MessageService.showMessageByCode("razaoSocial", null, Constants.alertMessage);

			return false;
            
        } else {

            if (fornecedorWidget.currentRow.NRINSJURFORN == null) {

                MessageService.showMessageByCode("preencherCNPJCPF", null, Constants.alertMessage);

            } else {

                if(fornecedorWidget.isValid()) {
                    
                    let inscricao = onlyNumbers(fornecedorWidget.currentRow.NRINSJURFORN);
                    
                    let novaParceria = '';
                    fornecedorWidget.currentRow.NRINSJURFORN = inscricao;
    
                    if (fornecedorWidget.currentRow.__is_new) {
    
                        let addressWidget = templateManager.container.getWidget("endprinc");
    
                        addressWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
                       
    
                        if(fornecedorWidget.isValid() && addressWidget.isValid() && addressWidget.currentRow.CDPAIS) {
                            
                            addressWidget.currentRow.NRCEPFORN = onlyNumbers(addressWidget.currentRow.NRCEPFORN);

                            if (parceiroNegocio && !fornecedorOutraFilial) {
    
                                Sup00800_Fornecedor_Service.getParceria(parceiroNegocio, 'FORNECEDOR').then(function (promisse) {
                                    let parceria = promisse.dataset.parceria[0];
                                    if (!parceria) {
                                        fornecedorWidget.currentRow.NRPARCNEGOCIO = parceiroNegocio;
                                        novaParceria = self.geraParceria(fornecedorWidget);
    
                                        if (novaParceria) {
    
                                            Sup00800_Fornecedor_Service.insereParceria(novaParceria).then(function () {
    
                                                General.saveCrud(fornecedorWidget).then(function() {
                                                    addressWidget.currentRow.CDFORNECED = fornecedorWidget.currentRow.CDFORNECED;
                                                    General.callRestEngine('cadSup#/fornecedorControler/salvarDigitoCST', 'Row', addressWidget.currentRow);
                                                    self.salvarEndereco(addressWidget);
                                                    self.changeReadOnlyFieldsForn(fornecedorWidget, false, []);
                                                    MessageService.successNotificationByCode("fornecedSucess");
    
                                                });
                                            });
                                        }
                                    } else {
    
                                        General.saveCrud(fornecedorWidget).then(function(){
                                            addressWidget.currentRow.CDFORNECED = fornecedorWidget.currentRow.CDFORNECED;
                                            General.callRestEngine('cadSup#/fornecedorControler/salvarDigitoCST', 'Row', addressWidget.currentRow);
                                            self.salvarEndereco(addressWidget);
                                            self.changeReadOnlyFieldsForn(fornecedorWidget, false, []);
                                            MessageService.successNotificationByCode("fornecedSucess");
                                        });
                                    }
                                });
                                
                            } else if (!fornecedorOutraFilial) {
    
                                let parceiro = self.validaParceiro(fornecedorWidget);
    
                                Sup00800_Fornecedor_Service.insereParceiro(parceiro).then(function (data) {
    
                                    fornecedorWidget.currentRow.NRPARCNEGOCIO = data.dataset.columnsToReturn[0].NRPARCNEGOCIO;
                                    novaParceria = self.geraParceria(fornecedorWidget);
                                    Sup00800_Fornecedor_Service.insereParceria(novaParceria);
    
                                    General.saveCrud(fornecedorWidget).then(function() { 
    
                                        addressWidget.currentRow.CDFORNECED = fornecedorWidget.currentRow.CDFORNECED;
                                        General.callRestEngine('cadSup#/fornecedorControler/salvarDigitoCST', 'Row', addressWidget.currentRow);
                                        self.salvarEndereco(addressWidget);
                                        self.changeReadOnlyFieldsForn(fornecedorWidget, false, []);
                                        MessageService.successNotificationByCode("fornecedSucess");
    
                                    });
                                });
                            }
                            else {
                                General.saveCrud(fornecedorWidget).then(function(){
                                    addressWidget.currentRow.CDFORNECED = fornecedorWidget.currentRow.CDFORNECED;
                                    MessageService.successNotificationByCode("fornecedSucess");
                                    ScreenService.closeSwipe();
                                    self.changeReadOnlyFieldsForn(fornecedorWidget, false, []);
                                });
                            }
                            self.habilitaEnderecoGeral();
                        } else {
                            self.validaCamposRequiredSave(fornecedorWidget, addressWidget);
                        }
                    }else{
                        General.saveCrud(fornecedorWidget).then(function(){
                            self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
                                templateManager.container.getWidget("parametrizacao"),
                                templateManager.container.getWidget("financeiro"),
                                templateManager.container.getWidget("contapagar"),
                                templateManager.container.getWidget("OBSERVACAO"),
                                templateManager.container.getWidget("pagamento"),
                                templateManager.container.getWidget("contacorrente"),
                                templateManager.container.getWidget("interlocutores")], true);
                                MessageService.successNotificationByCode("fornecedSucessEdit");
                        });
                    }
                }

            }
        }
    };

    function fixTheMask(currentRow, names) {
        
        names = typeof names === 'string' ? [ names ] : names;

        if(Array.isArray(names)) {
            names.forEach(name => {
                if(currentRow[name]) {
                    currentRow[name] = currentRow[name].replace(/[^0-9]/g, '');
                }
            });
        }

    }

    self.salvarEndereco = function(widget){
        let existeTipoEndereco = false;
        let tipoEnderecoFornecedor = widget.currentRow.IDTPENDEFORN;
        let tipoEnderecoParceiro = self.getTipoEndereco(tipoEnderecoFornecedor);
        let parceiro = widget.getParent().currentRow.NRPARCNEGOCIO;
        let nomeLogradouro = widget.currentRow.DSENDEFORN;
        let row = widget.currentRow;
        
        //campos de e-mail
        if(row.DSEMAILFORNNFE == null){
            row.DSEMAILFORNNFE = "";
        }
        if(row.DSEMAILFORNCTE == null){
            row.DSEMAILFORNCTE = "";
        }
        if(row.DSEMAILFORNMDFE == null){
            row.DSEMAILFORNMDFE = "";
        }
        
        
        //campo compactar arquivo
        let compactarArquivo = row.IDCOMPARQXMLFOR;
        
        if (row.__is_new) {
            widget.dataSource.data.forEach(function (endereco) {
                if (endereco.IDTPENDEFORN == tipoEnderecoFornecedor) {
                    existeTipoEndereco = true;
                }
            });
            if (widget.isValid()) {
                let names = [ 'NRTELRESIFOR', 'NRTELEFORN', 'NRTELEFORN1', 'NRCELULARFOR', 'NRFAXFORN' ];
                fixTheMask(widget.currentRow, names);

                self.concatenaCamposEndereco(row);
                row.changed = true;
                row.NRCEPFORN = row.NRCEPFORN ? row.NRCEPFORN.replace(/\.|\/|\-/g, '') : "";
                return widget.saveRow().then(function (response) {
                    if(row.IDCOMPARQXMLFOR != null && row.IDCOMPARQXMLFOR != "" ){
                        General.callRestEngine('cadSup#/fornecedorControler/salvarCompacArq', 'Row', row).then(function(success) {
                            widget.getParent().currentRow.IDCOMPARQXMLFOR = row.IDCOMPARQXMLFOR;
                        });
                    }
                    
                    row.changed = false;
                    row.__is_new = false;
                    Sup00800_Fornecedor_Service.getEnderecoParcNegocio(parceiro, tipoEnderecoParceiro).then(function (promisse) {
                        let endereco = promisse.dataset.enderecoparc[0];
                        if (!endereco) {
                            let enderecoParceiro = self.preparaEnderecoParceiro(widget);
                            Sup00800_Fornecedor_Service.insereEnderecoParceiro(enderecoParceiro);
                        }
                    });
                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload(); 
                });
            }
            
            if (widget.name == 'endprinc') {
                self.habilitaEnderecoGeral();
            }

        } else {
            let names = [ 'NRTELRESIFOR', 'NRTELEFORN', 'NRTELEFORN1', 'NRCELULARFOR', 'NRFAXFORNSEP' ];
            fixTheMask(widget.currentRow, names);
            self.concatenaCamposEndereco(row);
            self.masterDetailSave(widget);
        }
        
        row.DSENDEFORN = nomeLogradouro;
    };

    self.copiarEndereco = function(widget, row = null){
        const widgetFornecedor = templateManager.container.getWidget('fornecedor');
        row = row || widget.currentRow;
        let tipoEnderecoFornecedor = row.IDTPENDEFORN;
        let parceiro = widgetFornecedor.currentRow.NRPARCNEGOCIO;
        let tipoEnderecoParceiro = self.getTipoEndereco(tipoEnderecoFornecedor);
        let promise = ZHPromise.defer();
        row.DSEMAILFORNNFE = null || "";
        row.DSEMAILFORNCTE = null || "";
        row.DSEMAILFORNMDFE = null || "";
        row.NRCEPFORN = row.NRCEPFORN ? row.NRCEPFORN.replace(/\.|\/|\-/g, '') : "";
        row.changed = true;
        
        if(widget.name == 'endereco') {
            widget.getField("IDTPENDEFORNSELECT").dataSource.data = widget.getField("IDTPENDEFORNSELECT").dataSource.rawdata;
            self.checkIDTPENDEFORN();
        }
        if(widget.isValid()){
            self.concatenaCamposEndereco(row);
            return General.callRestEngine('cadSup#/endeforn_endereco/save', 'Row', row).then(function () {
                    row.changed = false;
                if (row.__is_new) {
                    row.__is_new = false;
                    widget.list();
                    widget.reload();
                }
                Sup00800_Fornecedor_Service.getEnderecoParcNegocio(parceiro, tipoEnderecoParceiro).then(function (promisse) {
                    let endereco = promisse.dataset.enderecoparc[0];
                    let currentRow = widget.currentRow;
                    currentRow.NRCEPFORN = currentRow.NRCEPFORN ? currentRow.NRCEPFORN.replace(/\.|\/|\-/g, '') : "";
                    currentRow.IDTPENDEFORN = row.IDTPENDEFORN;
                    if (!endereco && widget.isValid()) {
                        let enderecoParceiro = self.preparaEnderecoParceiro(widget);
                        Sup00800_Fornecedor_Service.insereEnderecoParceiro(enderecoParceiro);
                    }
                    promise.resolve();
                });
                return promise;
            }); 
        }   
        else{
            promise.reject();
        }
        return promise;
    };
    
    self.saveFormaPagamento = function(){
        let widgetPagamento = templateManager.container.getWidget('pagamento');
        let opcaoPagamento = widgetPagamento.getField('IDTPFORPGTFO').value();
        let widgetPrazos = templateManager.container.getWidget('modopagamento');
        
        if(widgetPagamento.isValid()) {
            if (opcaoPagamento == "V") {
                if(isValidPrazoPagamento(widgetPrazos)) {
                    self.setFieldsPgtoFixo(widgetPagamento);
                    salvarFormaPagamentoComPrazos(widgetPrazos);
                }
            } else if (opcaoPagamento == "F") {
    
                if(!valuesIsValid(widgetPagamento)) {
                    return;
                }
               
    
                self.setFieldsFormaPgto(widgetPagamento);
                self.masterDetailSave(widgetPagamento);
                Sup00800_Fornecedor_Service.removePrazoPagamento(widgetPrazos.dataSource.data).then(function (){
                        widgetPrazos.reload();
                    }
                );
                widgetPagamento.reload();
            } else {
                self.setFieldsFormaPgto(widgetPagamento);
                self.setFieldsPgtoFixo(widgetPagamento);
                self.masterDetailSave(widgetPagamento);
                Sup00800_Fornecedor_Service.removePrazoPagamento(widgetPrazos.dataSource.data).then(function (){
                        widgetPrazos.reload();
                    }
                );
                widgetPagamento.reload();
            }
        }
        
    };

    function valuesIsValid(widgetPagamento) {

        if( (widgetPagamento.currentRow.NRDIAPGFIXFO > 31 || widgetPagamento.currentRow.NRDIAPGFIXFO < 1)) {
            ScreenService.showMessage('Dia inválido.');
            return false;
        }

        if(widgetPagamento.currentRow.NRPARCPGTOFO < 1 || widgetPagamento.currentRow.NRPARCPGTOFO.toString().length > 2) {
            ScreenService.showMessage('Parcela inválida.');
            return false;
        }
        return true;
    }

    function processAfterSavePrazos() {
        const prazos = templateManager.container.getWidget("modopagamento");
        const fmpgto = templateManager.container.getWidget("pagamento");
        
        General.formWidgetSwitchTemplate(fmpgto);
        General.changeWidgetAcessibility(fmpgto.getParent().widgets, true);
        fmpgto.view();
        prazos.showCheckbox = false;
        prazos.getAction("adicionarPrazo").isVisible = false;
        prazos.getField("NRDIASPGTOFO").inlineEditable = "";
        prazos.getField("VRPERCPGTOFO").inlineEditable = "";
        
        prazos.dataSourceFilter = [
            {
                "name": "CDFORNECED",
                "operator": "=",
                "value": templateManager.container.getWidget('fornecedor').currentRow.CDFORNECED
            }    
        ];
        
        prazos.reload();
    }
    
    self.widgetTransform = function(){
        let widPagamento = templateManager.container.getWidget('pagamento');
        
        widPagamento.list();
        widPagamento.reload();
    };


    self.salvarContaCorrente = function(widget){
        if(widget.currentRow.CDBANCFORN == "" || widget.currentRow.CDAGENFORN == "" || widget.currentRow.CDCCORFORN == ""){
            MessageService.showMessageByCode("preencherObrigatorios", null, Constants.alertMessage);
            return false;
        }else{
            widget.currentRow.CDFORNECED = widget.getParent().getParent().currentRow.CDFORNECED;
            let mask = /\.|\/|\-/g;
            let chave = widget.currentRow.CDBANCFORN + widget.currentRow.CDAGENFORN + widget.currentRow.CDCCORFORN;
            widget.currentRow.CDCCORFORN = (widget.currentRow.CDCCORFORN)? widget.currentRow.CDCCORFORN.replace(mask, '') : '';
            widget.currentRow.CDAGENFORN = (widget.currentRow.CDAGENFORN)? widget.currentRow.CDAGENFORN.replace(mask, '') : '';
            widget.currentRow.NRINSCNABFOR = (widget.currentRow.NRINSCNABFOR)? widget.currentRow.NRINSCNABFOR.replace(mask, '') : '';
            let contaPrincipal = widget.dataSource.data.filter(function(data){
                if (data.IDCCORFORNPREF == 'S')
                    return data;
            });
            let principalAnterior = widget.dataSource.data.filter(function(data){
                if(data.IDCCORFORNPREF == 'S' && !data.changed){
                    return data;
                }
            });
            let contaAlterada = self.alteraContaPrincipal(principalAnterior[0]);
            if (widget.currentRow.__is_new){
                if (contaPrincipal && contaPrincipal.length > 1) {
                    let config = {
                        type: "question",
                        icon: "question",
                        success: function(success){
                            General.saveCrud(widget).then(function(){
                                Sup00800_Fornecedor_Service.insereContaCorrenteFornecedor([contaAlterada]).then(function(){
                                    widget.currentRow.__is_new = false;
                                    MessageService.successNotificationByCode("successOperation");
                                    widget.view();
                                    widget.list();
                                    widget.reload();
                                });
                            });
                        }
                    };
                    MessageService.confirmMessageByCode("existeCadastrada", null, config);
                }else{
                    General.saveCrud(widget).then(function(){
                        widget.currentRow.__is_new = false;
                        widget.view();
                        widget.list();
                        widget.reload(); 
                    });
                    MessageService.successNotificationByCode("successOperation");
                    widget.list();
                    widget.reload();
                }
            }else{
                if (contaPrincipal && contaPrincipal.length > 1) {
                    let config = {
                        type: "question",
                        icon: "question",
                        success: function(success){
                            General.callRestEngine('cadSup#/fornecedor_contacorrente', 'DataSet', [widget.currentRow, widget.backupRow]).then(function(){
                                Sup00800_Fornecedor_Service.insereContaCorrenteFornecedor([contaAlterada]);
                                ScreenService.closeSwipe().then(function() {
                                    widget.list();
                                    widget.reload(); 
                                });
                            });
                            MessageService.successNotificationByCode("successOperation");
                            widget.list();
                            widget.reload();
                        }
                    };
                    MessageService.confirmMessageByCode("contaJaCadastrada", null, config);
                }else{
                    General.callRestEngine('cadSup#/fornecedor_contacorrente', 'DataSet', [widget.currentRow, widget.backupRow]).then(function(){
                        widget.view();
                        ScreenService.closeSwipe().then(function() {
                            widget.list();
                            widget.reload(); 
                        });
                    });
                    MessageService.successNotificationByCode("successOperation");
                    widget.list();
                    widget.reload();
                }
            }
        }
    };


    self.alteraContaPrincipal = function (data){
        let objs   = {};
        for (let chave in data){
            if (chave.substr(0, 2) != '__') {
                if (chave == 'IDCCORFORNPREF')
                    objs[chave] = 'N';
                else
                    objs[chave] = data[chave];
            }
        }
        let isnew = '__is_new';
        //let change = 'change';
        objs[isnew] = false;
        //objs[change] = 'true';
        return objs;
    };

    self.setFieldsPgtoFixo = function(fornecedor){
        fornecedor.currentRow.NRDIAPGFIXFO = 1;
        fornecedor.currentRow.NRPARCPGTOFO = 1;
        fornecedor.currentRow.IDUTDIAPGTFO = 'E';
    };

    self.setFieldsFormaPgto = function(formpgto){
        formpgto.currentRow.CDFORMPGTO = null;
    };
    
    function validarDiasPrazoPagamento(dias, diasJaEncontrados) {
        let isValid = false;
        
        if (Util.isEmptyOrBlank(dias) || dias == 0) {
            MessageService.showMessageByCode("campoNumeroNaoPodeSerZero", null, Constants.alertMessage);
            return false;
        } else if (diasJaEncontrados.includes(dias)) {
            MessageService.showMessageByCode("prazoNaoDuplicados", null, Constants.alertMessage);
            return false;
        } else {
            isValid = true;
            diasJaEncontrados.push(dias);
        }
        
        return isValid;
    }
    
    function validarPercentualPrazoPagamento(percentual, percentuaisJaEncontrados) {
        let isValid = false;
        
        if (!isIntervaloPercentualValido(percentual)) {
            MessageService.showMessageByCode("percentualEntreUmECem", null, Constants.alertMessage);
        } else {
            percentuaisJaEncontrados.push(percentual);
            isValid = true;
        }
        
        return isValid;
    }
    
    /**
     * TODO: Corrigir bug que, ao selecionar um prazo para ser removido e o valor
     * do que restou for diferente de 100%, a função não barra.
     */
    function isValidPrazoPagamento(widgetPrazos) {
        const prazos = widgetPrazos.dataSource.data;
        let diasJaEncontrados = [];
        let percentuaisJaEncontrados = [];
        let prazoAtual, dias, percentual;
        
        for (let index = 0; index < prazos.length; index++) {
            prazoAtual = prazos[index];
            dias = prazoAtual.NRDIASPGTOFO;
            percentual = parseFloat(prazoAtual.VRPERCPGTOFO);
            
            if (Util.isEmptyOrBlank(dias) && Util.isEmptyOrBlank(percentual)) {
                MessageService.showMessageByCode("prencherCampos", null, Constants.alertMessage);
                return false;
            }
            
            if (!validarDiasPrazoPagamento(dias, diasJaEncontrados)) {
                return false;
            }
            
            if (!validarPercentualPrazoPagamento(percentual, percentuaisJaEncontrados)) {
                return false;
            }
        }
        
        const sum = function(accumulator, currentValue) {
            return parseFloat(accumulator) + parseFloat(currentValue);
        };
        const somaPercentuais = percentuaisJaEncontrados.reduce(sum, 0);
            
        if (somaPercentuais != 100) {
            MessageService.showMessageByCode("somaDosPercentuais", {"PARAM": somaPercentuais}, Constants.errorMessage);
            return false;
        }
        
        return true;
    }

    self.getTipoEndereco = function(idtpendeclie){
        let cdtipoendereco = "";
        let tipoEndereco = ['P', 'C', 'E', 'X', 'T', 'I'];
        let descTipoEndereco = ['PRINCIPAL', 'COBRANCA', 'EXTERIOR', 'EXPORTACAO', 'ENTREGA', 'INSCRICAO ESTADUAL'];
        for (i = 0; i < tipoEndereco.length; i++){
            if (idtpendeclie == tipoEndereco[i])
                cdtipoendereco = descTipoEndereco[i];
        }
        return cdtipoendereco;
    };

    self.concatenaCamposEndereco = function (endereco){
        endereco.DSENDEFORNSEP = endereco.DSENDEFORN;
        endereco.NRENDEFORNSEP = endereco.NUMERO;
        endereco.DSENDEFORN = (endereco.NUMERO)? endereco.DSENDEFORN + ", " + endereco.NUMERO : endereco.DSENDEFORN;
    };

    self.validaCamposRequiredSave = function (fornecedorWidget, addressWidget){
        if(!fornecedorWidget.isValid() && (!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS)) {
            if(addressWidget.isValid() && !addressWidget.currentRow.CDPAIS) {
                addressWidget.activate();

                addressWidget.isValid();

                fornecedorWidget.currentWidget = fornecedorWidget;
                fornecedorWidget.activate();
            } else addressWidget.isValid();
            MessageService.showMessageByCode("prencherCamposObrigatorios", null, Constants.alertMessage);
            return false;
        } else {
            if((!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS) && !addressWidget.isActive()) {
                addressWidget.activate();
                addressWidget.isValid();
            } else if(!fornecedorWidget.isValid() && !fornecedorWidget.isActive()) {
                fornecedorWidget.currentWidget = fornecedorWidget;
                fornecedorWidget.activate();
            }
            MessageService.showMessageByCode("campoObrigatorio", null, Constants.alertMessage);
            return false;
        }
    };

    self.validaParceiro = function(widget){
        let tipo = "";
        switch(widget.currentRow.IDTPIJURFORN){
            case "J": tipo = "CNPJ";
                break;
            case "O": tipo = "CODIGO";
                break;
            case "F": tipo = "CPF";
                break;
            default:
                tipo = "LIVRE";
        }
        if(widget.currentRow.__is_new) {
            return [{
                "CDTIPOINSCRICAO": tipo,
                "NRINSCRICAOPARC": widget.currentRow.NRINSJURFORN,
                "NMPRINCIPALPARC": widget.currentRow.NMRAZSOCFORN,
                "NMSECUNDARIPARC": widget.currentRow.NMFANTFORN,
                "CDTIPOPARCPRINCIPAL": "FORNECEDOR",
                "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
                "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
                "__is_new_code": true,
                "__new_code_pk": "PARCNEGOCIO",
                "__table_pk": "NRPARCNEGOCIO",
                "__new_code_length": 10,
                "__columns_to_return": [
                    "NRPARCNEGOCIO"
                ],
                "__is_new": true
            }];
        }
    };

    self.geraParceria = function(widget){
        return [{
            "NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO,
            "CDTIPOPARCEIRO": 'FORNECEDOR',
            "NRORG": getLocalVar('ERP_NRORGTRAB'),
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "PARCERIA",
            "__table_pk": "NRPARCERIA",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.preparaEnderecoParceiro = function(widget){
        let cdtipoendereco = self.getTipoEndereco(widget.currentRow.IDTPENDEFORN);
        return [{
            "NRPARCNEGOCIO": widget.getParent().currentRow.NRPARCNEGOCIO,
            "NRCEPENDERECO": widget.currentRow.NRCEPFORN.replace(/\.|\/|\-/g, ''),
            "CDTIPOENDERECO": cdtipoendereco,
            "DSENDERECO": widget.currentRow.DSENDEFORN,
            "CDLOGRADOURO": widget.currentRow.CDLOGRADOURO,
            "NRIMOVELENDERECO": widget.currentRow.NUMERO,
            "DSCOMPLEENDERECO": widget.currentRow.DSCOMPENDFOR,
            "CDPAIS": widget.currentRow.CDPAIS,
            "SGESTADO": widget.currentRow.SGESTADO,
            "CDMUNICIPIO": widget.currentRow.CDMUNICIPIO,
            "CDBAIRRO": widget.currentRow.CDBAIRFORN,
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "ENDERECOPARC",
            "__table_pk": "NRENDERECOPARC",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.habilitaEnderecoGeral = function(){
        templateManager.container.getWidget("endereco").isVisible = true;
        templateManager.container.getWidget("endprinc").isVisible = false;
        templateManager.container.getWidget("endprinc").showAsTab = false;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("financeiro"),
            templateManager.container.getWidget("contapagar"),
            templateManager.container.getWidget("OBSERVACAO"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("contacorrente"),
            templateManager.container.getWidget("interlocutores")], true);
    };

    self.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget){
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    self.criaCdfornecedor = function(widget){
        let inscricao = widget.currentRow.NRINSJURFORN.replace(/\.|\/|\-/g, '');
        let tipoInscricao = widget.currentRow.IDTPIJURFORN;
        widget.getField('CDFORNECED').setValue(tipoInscricao + inscricao);
    };



    self.getFieldById = function(widget, id) {
        return widget.fields.filter(function(field) {
            return field.id == id;
        })[0];
    };

    self.endeFornValidarCep = function(widget, CEP) {

        let reload = [];

        if(CEP.replaceAll("_","").length == 10) {
            Endereco.buscarCep(CEP).then(function(response) {

                let endereco = response.dataset.ENDERECO;
                self.setDataSourceEndereco(widget, endereco);

                if(endereco) {

                    widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
                    widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
                    widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
                    widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
                    widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
                    widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
                    widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';

                    if (widget.name.localeCompare('interlocutores') === 0) {

                        widget.currentRow.NMBAIRINTER = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
                        
                    } else {

                        widget.currentRow.NMBAIRFORN = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
                    }

                    widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
                    widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
                    widget.currentRow.DSENDEINFORN = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
                    widget.currentRow.DSENDEFORN = (endereco.DSENDERECO) ? widget.currentRow.DSENDEINFORN : '';

                } else if(!endereco || response.dataset.ERRO) {

                    if (widget.name.localeCompare('interlocutores') === 0) {

                        widget.currentRow.NRCEPINTERFO = '';

                    } else {

                        widget.currentRow.NRCEPFORN = '';
                    }
                }
                
                if(reload[0]) {

                    if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;
                    widget.getField("NMESTADO").reload();
                    
                    if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;
                    widget.getField("NMMUNICIPIO").reload();
                    
                    let bairro = null;

                    if (widget.name.localeCompare('interlocutores') === 0) {

                        bairro = widget.currentRow.NMBAIRINTER;

                    } else {

                        bairro = widget.currentRow.NMBAIRFORN;
                    }

                    if(!widget.currentRow.CDMUNICIPIO) widget.getField(bairro).readOnly = true;
                    widget.getField(bairro).reload();
                }
                // widget.redraw();
                // widget.reload();

            }.bind(self),function(error) {

                MessageService.showMessageByCode("cepNaoExiste", null, Constants.errorMessage);
                
                widget.currentRow.CDPAIS =  '';
                widget.currentRow.NMPAIS =  '';
                widget.currentRow.SGESTADO = '';
                widget.currentRow.NMESTADO =  '';
                widget.currentRow.CDMUNICIPIO =  '';
                widget.currentRow.NMMUNICIPIO = '';
                widget.currentRow.CDBAIRRO =  '';
                widget.currentRow.NMBAIRFORN = '';
                widget.currentRow.NRCEPFORN = '';
                widget.currentRow.DSENDEFORN = '';

            });
        }
    };

    self.setDataSourceEndereco = function(widget, endereco){
        if (widget.name.localeCompare('interlocutores') === 0){
            bairro = "NMBAIRINTER";
        }else{
            bairro = "NMBAIRFORN";
        }
        widget.getField("NMESTADO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": endereco.CDPAIS};
        widget.getField("NMESTADO").readOnly = false;
        widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": endereco.CDPAIS};
        widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {"name": "SGESTADO", "operator": "IN", "value": endereco.SGESTADO};
        widget.getField("NMMUNICIPIO").readOnly = false;
        widget.getField(bairro).readOnly = false;
        if(bairro == "NMBAIRINTER") {
            widget.getField(bairro).dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": endereco.CDPAIS};
            widget.getField(bairro).dataSourceFilter[1] = {"name": "SGESTADO", "operator": "IN", "value": endereco.SGESTADO};
            widget.getField(bairro).dataSourceFilter[2] = {"name": "CDMUNICIPIO", "operator": "IN", "value": endereco.CDMUNICIPIO};
        }
    };
    
    self.setCurrentRowForm = function (widget){
        
        if (widget.dataSource.data.length) {
            if(widget == templateManager.container.getWidget('parametrizacao')){
                if(widget.dataSource.data[0].IDTPENVAFNORMAL == null){
                   widget.dataSource.data[0].IDTPENVAFNORMAL = 'E'; 
                }
            }
            widget.currentRow = widget.dataSource.data[0];
        }
        
    };

    self.setDataSourceFilho = function(){
        let widgetPai = templateManager.container.getWidget('fornecedor');
        widgetPai.widgets.forEach(
            function (filha){
                if((filha.name !== 'filterPopup') && (filha.dataSourceFilter[0]))
                    filha.dataSourceFilter[0].value = widgetPai.currentRow.CDFORNECED;
            }
        );
        templateManager.container.getWidget('modopagamento').dataSourceFilter = [
            {
                "name": "CDFORNECED",
                "operator": "=",
                "value": widgetPai.currentRow.CDFORNECED
            }    
        ];
    };


    self.validateDigits = function(widget) {
        if(widget.currentRow.NRINSJURFORN)
        widget.currentRow.NRINSJURFORN = widget.currentRow.NRINSJURFORN.replace(/[^0-9]/g, '');
    };
    
    self.setFieldsOpcaoPagamento = function(widget){
        let fields = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO', 'NMFORMPGTO'];
        
        General.justInteger('#NRDIAPGFIXFO');
        General.justInteger('#NRPARCPGTOFO');
        
        self.exibicaoFormaPagamento(widget);
        
        /*switch(widget.currentRow.IDTPFORPGTFO){
            case "V": 
                self.habilitaGrid(widget.widgets[0]);
                self.formaPagamento(widget, fields);
                
                break;
            case "F": 
                self.pagamentoFixo(widget, fields);
                self.desabilitaGrid(widget.widgets[0]);
             
                break;
            default: 
                self.desabilitaGrid(widget.widgets[0]);
                self.desabilitaFields(widget, fields);
            
                break;
        }*/
    };
    
    function sanitizaNomeFormaPagamento(widget) {
        return widget.name === 'formaPagamento' ? 'IDTPFORPGTAF' : 'IDTPFORPGTFO';
    }
    
    self.exibicaoFormaPagamento = function(widget) {
        const nomeFormaPagamento = sanitizaNomeFormaPagamento(widget);
        const formaPagamento = widget.currentRow[nomeFormaPagamento];
        
        switch (formaPagamento) {
			default:
				widget.getField('NRDIAPGFIXFO').isVisible   = false;
				widget.getField('NRPARCPGTOFO').isVisible   = false;
				widget.getField('IDUTDIAPGTFO').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXFO').validations = {};
				widget.getField('NRPARCPGTOFO').validations = {};
				break;
			case 'F':
				widget.getField('NRDIAPGFIXFO').isVisible   = true;
				widget.getField('NRPARCPGTOFO').isVisible   = true;
				widget.getField('IDUTDIAPGTFO').isVisible   = true;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXFO').validations = {required: true};
				widget.getField('NRPARCPGTOFO').validations = { required: true, max: { value: 99 } };
				break;
			case 'V':
				widget.getField('NRDIAPGFIXFO').isVisible   = false;
				widget.getField('NRPARCPGTOFO').isVisible   = false;
				widget.getField('IDUTDIAPGTFO').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = true;
				widget.getField('PRAZOSBUTTON').isVisible   = true;
				widget.getField('NMFORMPGTO').validations   = {required: true};
				widget.getField('NRDIAPGFIXFO').validations = {};
				widget.getField('NRPARCPGTOFO').validations = {};
				break;
		}
    };
    
    this.setDataSourceFilterPrazos = function () {
        const modopagamento = templateManager.container.getWidget('modopagamento');
        
        modopagamento.dataSourceFilter = [
            {
                "name": "CDFORNECED",
                "operator": "=",
                "value": templateManager.container.getWidget('fornecedor').currentRow.CDFORNECED
            }    
        ];
        
        modopagamento.reload();
    };
    
    this.abrePrazoPercentual = function(widget) {
        const modopagamento = widget.container.getWidget("modopagamento");
        if(widget.isValid() || widget.mode == "view"){
            ScreenService.openPopup(modopagamento);
        }
    };
    
    this.editarFormaPgto = function(widget) {
        const prazo = widget.container.getWidget("modopagamento");
        
        enableEditPrazosFormaPgto(prazo);
        
        General.widgetEdit(widget);
    };
    
    function enableEditPrazosFormaPgto(widget) {
        widget.backupData = angular.copy(widget.dataSource.data);
        widget.showCheckbox = true;
        widget.getAction("adicionarPrazo").isVisible = true;
        
        widget.getField("NRDIASPGTOFO").inlineEditable = "number";
        widget.getField("VRPERCPGTOFO").inlineEditable = "number";
    }
    
    this.cancelarFormaPagamento = function(widget) {
        const prazo = widget.container.getWidget("modopagamento");
        
        disableEditPrazosFormaPgto(prazo);
        
        General.widgetCancelForm(widget);
        this.exibicaoFormaPagamento(widget);
    };
    
    function disableEditPrazosFormaPgto(widget) {
        widget.reload();
        widget.showCheckbox = false;
        widget.getAction("adicionarPrazo").isVisible = false;
        
        delete widget.getField("NRDIASPGTOFO").inlineEditable;
        delete widget.getField("VRPERCPGTOFO").inlineEditable;
    }
    
    this.voltarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        
        widget.dataSource.data = widget.dataSource.data.filter(function(row) {
            return row[percentualName] != 0 && row[diasName] != 0;
        });
        ScreenService.closePopup();
        templateManager.container.getWidget('pagamento').activate();
    };
    
    this.cancelarPrazo = function(widget) {
        widget.reload();
        widget.list();
    };
    
    this.adicionaPrazo = function(widget, dadosFornecedor) {
        widget.newRow();
        widget.currentRow.CDFORNECED  = dadosFornecedor.currentRow.CDFORNECED;
    };
    
    this.excluirPrazo = function(widget) {
        let checkedRows = widget.getCheckedRows();
        checkedRows.forEach(function(row) {
            let index = widget.dataSource.data.indexOf(row);
			widget.dataSource.data.splice(index, 1);
        });
        widget.unSelectAll();
    };
    
    this.justInt = function(widget) {
        const { diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        const diasNameInline = diasName + '_inline';
        
        widget.currentRow[diasName] = parseInt(widget.currentRow[diasName], 10);
        widget.currentRow[diasNameInline] = parseInt(widget.currentRow[diasName], 10);
    };
    
    function sanitizaNomeFieldsPercentualAndDiaPrazo(widgetPrazoPercentual) {
        const fields = {
            percentualName: '',
            diasName: ''
        };
        
        fields.percentualName = 'VRPERCPGTOFO';
        fields.diasName = 'NRDIASPGTOFO';
        
        return fields;
    }
    
    this.confirmarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        let total = 0;
        let prazos = widget.dataSource.data;
        prazos.forEach(function(row) {
            let index = prazos.indexOf(row);
            if (row[percentualName] == 0) {
                prazos.splice(index, 1);
            }
		});
		
        for(let i = 0; i < prazos.length; i++) {
            let valor  = parseFloat(prazos[i][percentualName]);
            let nrdia = parseFloat(prazos[i][diasName]); 
            total += valor;
            
            if(nrdia > 999 || nrdia < 0) {
                MessageService.showMessageByCode("prazoDias", null, Constants.alertMessage);
                return false;
            }
            let existe = 0;
            for(let j = 0; j < prazos.length; j++) {
                if(prazos[j][diasName] == nrdia)
                    existe++;
            }
			if(existe > 1) {
			    MessageService.showMessageByCode("prazoDiasCadastrados", null, Constants.alertMessage);
                return false;
			}
        }
        
        if(total != 100) {
            MessageService.showMessageByCode("somaDosPercentuaisDosPrazos", null, Constants.alertMessage);
            return false;
        }
        
        widget.list();
        ScreenService.closePopup();
    };

    self.desabilitaFields = function(widget, fields){
        fields.forEach(field => {
            widget.getField(field).isVisible = false;
            widget.getField(field).reload();
        });
    };

    self.pagamentoFixo = function(widget, fields){
        fields.forEach(field => {
            widget.getField(field).isVisible = field == 'NMFORMPGTO' ? false : true;
            widget.getField(field).reload();
        });
    };

    self.formaPagamento = function(widget, fields){
        fields.forEach(field => {
            widget.getField(field).isVisible = (field == 'NMFORMPGTO');
            widget.getField(field).reload();
        });
    };

    self.desabilitaGrid = function(widget) {
        widget.isVisible = false;
        widget.getAction('SAVE').isVisible= true;
        widget.getAction('ADD').isVisible= false;
    };

    self.habilitaGrid = function(widget) {
        
        let row = widget.getParent().currentRow;
        
        widget.isVisible = true;
        widget.getAction('SAVE').isVisible  = false;
        if((row.CDFILIFORN == null && row.IDFUNCAOFILI != 'F' && row.FRANQUEADORA > 0) || row.IDTPFORPGTFO == 'V') {
            widget.getAction('ADD').isVisible   = true;
        }
    };
    
    self.limpaCampo = function (widget, codigo, name, txt){
        codigo = null;
        name = null;
        widget.getField(txt).clearValue();
    };

    this.filtraEstado = function(widget) {
        const fieldEstado = widget.getField('NMESTADO');
        const pais = widget.currentRow.CDPAIS;

    
        if (widget.currentRow.CDPAIS === "") {
            fieldEstado.readOnly = true;
        }
        else {
            fieldEstado.dataSourceFilter[0].value = pais;
            fieldEstado.readOnly = false;
        }
        
        widget.currentRow.SGESTADO = null;
        widget.currentRow.NMESTADO = null;
        widget.getField('NMESTADO').clearValue();
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.NMMUNICIPIO = null;
        widget.getField('NMMUNICIPIO').clearValue();
        widget.currentRow.CDBAIRRO = null;
        widget.currentRow.NMBAIRFORN = null;
        widget.getField('NMBAIRFORN').clearValue();
   
        widget.getField('NMBAIRFORN').readOnly = true;
        widget.getField('NMMUNICIPIO').readOnly = true;
    };
    
    this.filtraMunicipio = function(widget) {
        const fieldMunicipio = widget.getField('NMMUNICIPIO');
        const estado = widget.currentRow.SGESTADO;
        

        
        if (widget.currentRow.SGESTADO === "") {
            fieldMunicipio.readOnly = true;
        }
        else {
            fieldMunicipio.dataSourceFilter[0].value = estado;
            fieldMunicipio.readOnly = false;
        }
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.NMMUNICIPIO = null;
        widget.getField('NMMUNICIPIO').clearValue();
        
        widget.currentRow.CDBAIRRO = null;
        widget.currentRow.NMBAIRFORN = null;
        widget.getField('NMBAIRFORN').clearValue();
        widget.getField('NMBAIRFORN').readOnly = true;
    };
    
    this.filtraBairro = function(widget) {
        const fieldBairro = widget.getField('NMBAIRFORN');
        const municipio = widget.currentRow.CDMUNICIPIO;
        

        if (widget.currentRow.CDMUNICIPIO === "") {
            fieldBairro.readOnly = true;
        }
        else {
            fieldBairro.dataSourceFilter[0].value = municipio;
            fieldBairro.readOnly = false;
        }
        widget.currentRow.CDBAIRRO = null;
        widget.currentRow.NMBAIRFORN = null;
        widget.getField('NMBAIRFORN').clearValue();
        
    };
    
    function fixTheEditMask(fields, widget) {
         fields = typeof fields === 'string' ? [ fields ] : fields;

        if(Array.isArray(fields)) {
            fields.forEach(field => {
                if(widget.currentRow[field]) {
                    widget.currentRow[field] = DecodeValueFieldService.model(widget.getField(field), widget.currentRow[field]);
                }
            });
        }
    }

    
    self.checkAddressWithProviderNeighborhood = function(widget) {
        let fields = [ 'NRTELRESIFOR', 'NRTELEFORN', 'NRTELEFORN1', 'NRCELULARFOR', 'NRFAXFORNSEP' ];
        
        fixTheEditMask(fields, widget);

        let bairro = null;

        if (widget.name.localeCompare('interlocutores') === 0) {
            bairro = 'NMBAIRINTER';
        } else {
            bairro = 'NMBAIRFORN';
        }

        let reload = self.endefornSetMainFields(widget, bairro);

        if(reload[0]) {

            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = null;

            if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

        }

        if(reload[1]) {
            widget.currentRow.CDMUNICIPIO = null;
            widget.currentRow.NMMUNICIPIO = null;

            if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

        }

        if(reload[2]) {
            widget.currentRow.CDBAIRRO = null;
            if (widget.name.localeCompare('interlocutores') === 0){
                widget.currentRow.NMBAIRINTER = null;
            }else{
                widget.currentRow.NMBAIRFORN = null;
            }
            if(!widget.currentRow.CDMUNICIPIO)
                widget.getField(bairro).readOnly = true;

        }
    };

    self.endefornSetMainFields = function(widget, bairro) {
        let reload =  [true, true, true];
        let currentRow = widget.currentRow;
        let paisCurrentRow = currentRow.CDPAIS;
        let estadoCurrentRow = currentRow.SGESTADO;
        let municipioCurrentRow = currentRow.CDMUNICIPIO;
        let estadoField = widget.getField('NMESTADO');
        let municipioField = widget.getField('NMMUNICIPIO');
        let bairroField = widget.getField(bairro);

        if(paisCurrentRow){
            reload[0] = false;
            estadoField.readOnly = false;
            estadoField.dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": paisCurrentRow};
            
            if(estadoCurrentRow){
                reload[1] = false;
                municipioField.readOnly = false;
                municipioField.dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": paisCurrentRow};
                municipioField.dataSourceFilter[1] = {"name": "SGESTADO", "operator": "IN", "value": estadoCurrentRow};

                if(municipioCurrentRow){
                    reload[2] = false;
                    bairroField.readOnly = false;
                    if(bairro == "NMBAIRINTER") {
                        bairroField.dataSourceFilter[0] = {"name": "CDPAIS", "operator": "IN", "value": paisCurrentRow};
                        bairroField.dataSourceFilter[1] = {"name": "SGESTADO", "operator": "IN", "value": estadoCurrentRow};
                        bairroField.dataSourceFilter[2] = {"name": "CDMUNICIPIO", "operator": "IN", "value": municipioCurrentRow};
                    }
                }
            }
        }
        
        return reload;
    };

    self.changeWidgetVisibility = function(widgets, isEnable) {
        widgets.forEach(function(widget){
            widget.enabled = isEnable;
        });
    };

    self.masterDetailCancelForm = function(widget) {

        if(self.formChangeTemplate(widget) && widget.getParent()) {
            let widgets = widget.getParent().widgets;

            self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
        } else self.changeWidgetAcessibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            let indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
        
        if(widget == templateManager.container.getWidget('interlocutores')){
            if(widget.currentRow.__is_new) {
                widget.list();    
            } else {
                widget.view();
            }
            
            widget.activate();
            widget.reload();  
        }
    };
 
    self.masterDetailEdit = function(widget) {
        if(!widget.editing) {
            if(self.formChangeTemplate(widget) && widget.getParent()) {
                let widgets = widget.getParent().widgets;

                self.changeWidgetAcessibility(widgets.filter(function(w) {return w.name != widget.name;}).concat(widget.getParent()), false);
            } else self.changeWidgetAcessibility(widget.widgets, false);

            widget.backupRow = Util.clone(widget.currentRow);
            widget.edit();
           // widget.reload();
        }
    };
    
    self.editaFornecedor = function(widget) {
        widget.getField("NRINSJURFORN").readOnly = true;
        self.masterDetailEdit(widget);
    };
    
    self.financeiroEdit = function(widget) {
        if(!widget.editing) {
            if(self.formChangeTemplate(widget) && widget.getParent()) {
                let widgets = widget.getParent().widgets;
                let parentWidgets = widget.getParent().getParent().widgets;
                let fornecedor = templateManager.container.getWidget('fornecedor');
                
                fornecedor.enabled = false;

                self.changeWidgetAcessibility(widgets.filter(function(w) {return w.name != widget.name;}).concat(widget.parent), false);
                self.changeWidgetAcessibility(parentWidgets.filter(function(w) {return w.name != widget.name;}).concat(widget.parent), false);
            } else{
                self.changeWidgetAcessibility(widget.widgets, false);
                self.changeWidgetAcessibility(widget.parentWidgets, false);
            } 
            

            widget.backupRow = Util.clone(widget.currentRow);
            widget.edit();
        }
    };
    
    self.financeiroCancel = function(widget) {

        if(self.formChangeTemplate(widget) && widget.getParent()) {
            let widgets = widget.getParent().widgets;
            let parentWidgets = widget.getParent().getParent().widgets;
            let fornecedor = templateManager.container.getWidget("fornecedor");

            self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
            self.changeWidgetAcessibility(parentWidgets.concat(widget.getParent()), true);
            fornecedor.enabled = true;
        } else {
            self.changeWidgetAcessibility(widget.widgets, true);
            self.changeWidgetAcessibility(widget.parentWidgets, true);
        }
        if(widget.currentRow.__is_new) {
            widget.list();
            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };
    
    self.habilitaAbas = function(widget) {

        if(self.formChangeTemplate(widget) && widget.getParent()) {
            let widgets = widget.getParent().widgets;
            let parentWidgets = widget.getParent().getParent().widgets;
            let fornecedor = templateManager.container.getWidget("fornecedor");

            self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
            self.changeWidgetAcessibility(parentWidgets.concat(widget.getParent()), true);
            fornecedor.enabled = true;
        } else {
            self.changeWidgetAcessibility(widget.widgets, true);
            self.changeWidgetAcessibility(widget.parentWidgets, true);
        }
        if(widget.currentRow.__is_new) {
            widget.list();
            ScreenService.closeSwipe();
        } else {
            widget.view();
        }
    };
    
    self.masterDetailGoBackToList = function(widget) {
        ScreenService.closeSwipe();
        if(widget.name != 'endereco' && widget.name != 'codigospix' && widget.name != 'contacorrente' && widget.name != 'modopagamento' && widget.name != 'interlocutores'){
            templateManager.container.getWidget('fornecedor').getAction('INATIVAR').isVisible = true;
        }
        widget.list();
    };

    self.masterDetailGoBackToParent = function(widget) {
        ScreenService.closeSwipe().then(function(){
            templateManager.container.getWidget('fornecedor').getAction('INATIVAR').isVisible = true;
            if(widget == templateManager.container.getWidget('contapagar') || widget == templateManager.container.getWidget('codigospix') || widget == templateManager.container.getWidget('contacorrente') || widget == templateManager.container.getWidget('modopagamento')){
                widget.getParent().getParent().list();
                widget.deactivate();
                widget.getParent().getParent().activate();
                widget.getParent().getParent().reload();
            } else {
                widget.getParent().list();
                widget.deactivate();
                widget.getParent().activate();
                widget.getParent().reload();     
            }
        });
    };
    
    self.validaEmailMultiplo = function(widget,name){
        const field = widget.getField(name); 
        let fieldValue = widget.getField(name).value();
        
        if(fieldValue){
            const emails = fieldValue.replaceAll(";",",").split(",");
            const regex = /^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/;
            field.validations = {};
            
            for (let i = 0; i < emails.length; i++) {
                if(emails[i] == "" || !regex.test(emails[i])){
                    field.validations.mail = true;
                }
            }
            
            field.setValue(fieldValue);
            field.validate(fieldValue);
            templateManager.updateTemplate();
        }
    };
    
    self.goBackOnView = function(widget) {
        ScreenService.closeSwipe().then(function(){
            widget.getParent().list();
            widget.deactivate();
            widget.getParent().activate();
            widget.getParent().reload();   
        });
    };

    self.deleteInterlocutor = function(widget) {
        General.deleteCrud(widget);
    };

    self.masterDetailNewRow = function(widget) {
        // let widget = templateManager.container.getActiveWidget();
        
        self.changeWidgetAcessibility(widget.widgets, false);
        
        widget.newRow();
        widget.currentRow.IDTIPENDINTE = "R";
    };

    self.masterDetailSave = function(widget) {
         if(!widget.currentRow.VRPEDESCFORN) {
                widget.currentRow.VRPEDESCFORN = 0;
            }
        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }
            
            widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                
                if(widget == templateManager.container.getWidget('endereco') || widget == templateManager.container.getWidget('endprinc')){
                    if(widget.currentRow.IDCOMPARQXMLFOR != null && widget.currentRow.IDCOMPARQXMLFOR != ""){
                        General.callRestEngine('cadSup#/fornecedorControler/salvarCompacArq', 'Row', widget.currentRow).then(function(success) {
                            widget.getParent().currentRow.IDCOMPARQXMLFOR = widget.currentRow.IDCOMPARQXMLFOR;
                        });
                    }
                }
                
                if(self.formChangeTemplate(widget) && widget.getParent()) {
                    
                    widget.list();
                    
                    let widgets = widget.getParent().widgets;
                    self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
                } else {
                    if(widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                        widget.list();
                    } else {
                        widget.list();
                    }
                    
                    if(widget == templateManager.container.getWidget('interlocutores')){
                        widget.view();
                        ScreenService.closeSwipe();
                        widget.list();
                    }

                    self.changeWidgetAcessibility(widget.widgets, true);
                }

                if(widget.currentRow.__is_new) {
                    widget.currentRow.__is_new = false;
                } else{
                    widget.reload();
                }
                if(widget == templateManager.container.getWidget('endereco')){
                    widget.view();
                    widget.reload();
                }
            }.bind(self), function(error) {
                
                if(widget == templateManager.container.getWidget('interlocutores')){
                    ScreenService.closeSwipe();
                    templateManager.container.getWidget('interlocutores').reload();
                }
                
                showGenericError(error);
                
                widget.getParent().list();
            });     
        } else {
            if(widget == templateManager.container.getWidget('parametrizacao')){
                if(widget.getField('NMTPBAIXAPAG').value() == "" || widget.getField('VRPEDESCFORN').value() == null){
                    widget.fieldGroups[1].opened = true;
                }  
            }
            
            return false;
        }
    };

    self.masterDetailSaveForm = function() {
        let widget = templateManager.container.getActiveWidget();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }

            return widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;

                widget.reload();

                self.changeWidgetVisibility(widget.widgets, true);
            }.bind(self));

        }
    };

    self.formChangeTemplate = function(widget) {
        // widget = templateManager.container.getActiveWidget();
        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.unMask = function(str) {
        if(typeof str === 'string' && str.indexOf('R$') != -1)
            str = $.currency.unmaskString(str, {"thousands": "."});
        else if(typeof str === 'string' && str.indexOf('%') != -1)
            str = parseFloat(str.replace(',', '.'));
        else str = str.replace(/[\D]+/g,'');
        return str;
    };
    
    /*****************************
     * FORMA DE PAGAMENTO: Begin *
     *****************************/
    
    self.adicionarPrazo = function(widgetGrid){
        const widgetPagamento = templateManager.container.getWidget('pagamento');
        
        if (widgetPagamento.getField('NMFORMPGTO').value()) {
            widgetGrid.newRow();
            widgetGrid.currentRow.CDFORNECED = widgetPagamento.currentRow.CDFORNECED;
        } else {
            MessageService.showMessageByCode("formaDePagamentoDeveSerInformada", null, Constants.alertMessage);
        }
    };
    
    this.removerPrazo = function() {
        const widgetPrazos = templateManager.container.getWidget('modopagamento');
        const prazosSelecionados = widgetPrazos.getCheckedRows();
        const prazosExistentes = widgetPrazos.dataSource.data;
        
        if (prazosSelecionados.length === prazosExistentes.length) {
            MessageService.showMessageByCode("manterPrazo", null, Constants.alertMessage);
        } else {
            widgetPrazos.dataSource.data = prazosExistentes.filter(prazo => !prazo.__isSelected);
            self.prazosParaRemover = [ ...self.prazosParaRemover, prazosSelecionados ];
            
            widgetPrazos.dataSource.clearCheckedRows();
        }
    };
    
    function getWidgetsExcetoEscolhida(widgetExcecao) {
        const widgetFornecedor = templateManager.container.getWidget('fornecedor');
        const widgetsExcetoEscolhida = function(widget) {
            return widget.name !== widgetExcecao.name;
        };
        
        return widgetFornecedor.widgets.filter(widgetsExcetoEscolhida).concat(widgetFornecedor);
    }
    
    self.editarFormaPagamento = function(widgetGrid) {
        const ativarWidget = false;
        const widgetPagamento =  widgetGrid.container.getWidget('pagamento');
        
        self.changeWidgetAcessibility(getWidgetsExcetoEscolhida(widgetPagamento), ativarWidget);
        widgetPagamento.editing = !ativarWidget;
        
        const namefieldsToUnlock = ['IDTPFORPGTFO', 'NRDIAPGFIXFO', 'NRPARCPGTOFO', 'NMFORMPGTO'];
        const fieldsInlineEdit = ['NRDIASPGTOFO', 'VRPERCPGTOFO'];
        const actionsToShow = ['ADD', 'SAVE'];
        
        namefieldsToUnlock.forEach(name => {
            widgetPagamento.getField(name).readOnly = false;
        });
        
        widgetGrid.actions.filter(action => actionsToShow.includes(action.name)).forEach(action => action.isVisible = true);
        widgetGrid.fields.filter(field => fieldsInlineEdit.includes(field.name)).forEach(field => field.inlineEditable = 'number');
        
        widgetGrid.edit();
        widgetGrid.showCheckbox = true;
        widgetGrid.backupDataSourceFilter = angular.copy(widgetGrid.dataSourceFilter);
        
        self.prazosParaRemover = [];
    };
    
    self.cancelarPrazosPagamento = function(widgetPrazos){
        const actionsToShow = ['ADD', 'SAVE'];
        const fieldsInlineEdit = ['NRDIASPGTOFO', 'VRPERCPGTOFO'];
        const ativarWidget = true;
        const widgetPagamento =  widgetPrazos.container.getWidget('pagamento');
        const nomeWidgetExcecao = widgetPagamento.name;
        
        self.changeWidgetAcessibility(getWidgetsExcetoEscolhida(widgetPrazos, nomeWidgetExcecao), ativarWidget);
        widgetPagamento.editing = !ativarWidget;
        
        widgetPrazos.actions.filter(action => actionsToShow.includes(action.name)).forEach(action => action.isVisible = false);
        widgetPrazos.fields.filter(field => fieldsInlineEdit.includes(field.name)).forEach(field => field.inlineEditable = '');
        widgetPrazos.showCheckbox = false;
        widgetPrazos.list();
        
        const namefieldsToLock = ['IDTPFORPGTFO', 'NRDIAPGFIXFO', 'NRPARCPGTOFO', 'NMFORMPGTO'];
        
        widgetPagamento.fields.filter(field => namefieldsToLock.includes(field.name)).forEach(field => field.readOnly = true);
        
        widgetPagamento.reload();
        widgetPrazos.dataSourceFilter = widgetPrazos.backupDataSourceFilter;
        widgetPrazos.reload();
    };
    
    function isIntervaloPercentualValido(valorPercentual) {
        return valorPercentual >= 1 && valorPercentual <= 100;
    }
    
    /*****************************
     *  FORMA DE PAGAMENTO: End  *
     *****************************/
    
    self.setGridModoPagamento = function(){
        let widModoPag = templateManager.container.getWidget('modopagamento');
        widModoPag.getField('NMFORMPGTO').setValue(templateManager.container.getWidget('pagamento').getField('NMFORMPGTO').value());
        Sup00800_Fornecedor_Service.removePrazoPagamento(widModoPag.dataSource.data);
        // widModoPag.reload();
    };
    
    this.edit = function(widget) {
        General.widgetEdit(widget);
    };
    
    /**
     * TODO: Necessário entender como o CRUD funciona para que os erros de:
     * - remover todas as rows (mesmo as que não foram selecionadas);
     * - "Cannot find row to update." ao passar rows para serem excluídas;
     * - remover a forma de pagamento toda mesmo quando não foi passada essa alternativa.
     */
    function salvarFormaPagamentoComPrazos(widgetPrazos) {
        
        const widgetFormaPagamento = templateManager.container.getWidget('pagamento');
        
        //General.callRestEngine('cadSup#/fornecedor_formpgto', 'Row', {"CDFORNECED": widgetFormaPagamento.currentRow.CDFORNECED}).then(function(success){
            return General.saveCrud(widgetFormaPagamento).then(function(success) {
                
                widgetPrazos.dataSource.data.forEach(function(dados){
                    dados.NRDIASPGTOFO = parseFloat(dados.NRDIASPGTOFO);
                    dados.VRPERCPGTOFO = parseFloat(dados.VRPERCPGTOFO);
                });
                
                General.callRestEngine('cadSup#/fornecedorControler/salvarPrazos', 'Row', widgetPrazos.dataSource.data).then(function(success){
                    processAfterSavePrazos();
                }).catch(function(error) {
                    showGenericError(error);
                });
            });
    }
    
    self.checkAddress = function(widget) {
        let bairro = null;
        if (widget.name.localeCompare('interlocutores') === 0){
            bairro = 'NMBAIRINTER';
        }else{
            bairro = 'NMBAIRFORN';
        }
        let reload = self.atualizafiltroEndereco(widget, bairro);

        if(reload[0]) {
            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = null;

            if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

            widget.getField("NMESTADO").reload();
        }

        if(reload[1]) {
            widget.currentRow.CDMUNICIPIO = null;
            widget.currentRow.NMMUNICIPIO = null;

            if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

            widget.getField("NMMUNICIPIO").reload();
        }

        if(reload[2]) {
            widget.currentRow.CDBAIRRO = null;
            if (widget.name.localeCompare('interlocutores') === 0){
                widget.currentRow.NMBAIRINTER = null;
            }else{
                widget.currentRow.NMBAIRFORN = null;
            }
            if(!widget.currentRow.CDMUNICIPIO)
                widget.getField(bairro).readOnly = true;

            widget.getField(bairro).reload();
        }
    };

    self.atualizafiltroEndereco = function(widget, bairro) {
        let reload =  [false, false, false];

        if(widget.currentRow.CDPAIS) {
            widget.getField("NMESTADO").readOnly = false;

            if(widget.getField("NMESTADO").dataSourceFilter[0])
                if(widget.getField("NMESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

            widget.getField("NMESTADO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};

            if(widget.currentRow.SGESTADO) {
                widget.getField("NMMUNICIPIO").readOnly = false;

                if(widget.getField("NMMUNICIPIO").dataSourceFilter[0])
                    if(widget.getField("NMMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("NMMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

                widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};
                widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": widget.currentRow.SGESTADO};

                if(widget.currentRow.CDMUNICIPIO) {
                    widget.getField(bairro).readOnly = false;

                    if(widget.getField(bairro).dataSourceFilter[0])
                        if(widget.getField(bairro).dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField(bairro).dataSourceFilter[1].value != widget.currentRow.SGESTADO || widget.getField(bairro).dataSourceFilter[2].value != widget.currentRow.CDMUNICIPIO) reload[2] = true;

                    widget.getField(bairro).dataSourceFilter[0] = {"name": "CDPAIS", "operator": "=", "value": widget.currentRow.CDPAIS};
                    widget.getField(bairro).dataSourceFilter[1] = {"name": "SGESTADO", "operator": "=", "value": widget.currentRow.SGESTADO};
                    widget.getField(bairro).dataSourceFilter[2] = {"name": "CDMUNICIPIO", "operator": "=", "value": widget.currentRow.CDMUNICIPIO};
                } else reload[2] = true;
            } else reload[1] = reload[2] = true;
        } else reload[0] = reload [1] = reload[2] = true;

        return reload;
    };
    
    /**
     * Busca as informações do fornecedor, na widget de fornecedor (pai da widget
     * de parametrização), e define as mesmas na currentRow da widget de parametrização.
     * 
     * @param {object} widget widget de parametrização.
    */
    this.setProviderInfosOnParamsWidgetCurrentRowToFilter = function(widget){
        let parentWidgetCurrentRow = widget.getParent().currentRow;    
        let currentRow = widget.currentRow;
        
        currentRow.CDFORNECED = parentWidgetCurrentRow.CDFORNECED;
        currentRow.NRORG = parentWidgetCurrentRow.NRORG;
        
        if(widget.currentRow.IDTPENVAFNORMAL == null){
            widget.currentRow.IDTPENVAFNORMAL = 'E';
            widget.getParent().currentRow.IDTPENVAFNORMAL = 'E';
        }
        
    };
    
    //TELA DE CONTAS A PAGAR
    
    let hasDuplicateKeys = function(widget) {
        let codFornecedor = widget.currentRow.CDFORNECED;
        let arr = widget.dataSource.data.filter(function(data) {
            return (data.CDFORNECED === codFornecedor);
        });
        return (arr.length > 1);
    };

    this.saveParametrizacao = function(widget) {
        if (widget.isValid()) {
            if (!hasDuplicateKeys(widget)) {
                General.saveCrud(widget);
            }
            else {
                MessageService.showMessageByCode("parametrizacaoExistente", null, Constants.infoMessage);
            }
        }
    };

    this.validateParametersExistance = function(widget) {
        if ((widget.dataSource.data.length === 0) && (widget.dataSourceFilter.length > 0)) {
            widget.newRow();
            General.justInteger('#NRDIASBLOQNFFOR');
            popupWidget = widget.container.getWidget("filterPopup");
            widget.currentRow.CDFORNECED = popupWidget.currentRow.CDFORNECED;
            widget.currentRow.NMRAZSOCFORN = popupWidget.currentRow.NMRAZSOCFORN;
        }
    };
    
    //Códigos após a alteração e correção das telas

    this.salvarObservacao = function(widget){
        let widgetFornecedor = templateManager.container.getWidget('fornecedor');
        let widgets = widgetFornecedor.widgets;
        
        if(widget.currentRow.DSOBSERVFORN.length > 1924) {
            MessageService.showMessageByCode("ultrapassaLimite", null, Constants.alertMessage);
        } else {
            General.callRestEngine('cadSup#/fornecedorControler/saveObservacao', 'Row', widget.currentRow).then(function(success) {
                self.changeWidgetAcessibility(widgets.concat(widgetFornecedor), true);
                widget.view();
            },function(error) {
                showGenericError(error);
            }); 
        }
    };
    
    this.carregarFornecedor = function(){
        let widget = templateManager.container.getWidget('OBSERVACAO');
        
        widget.currentRow.CDFORNECED = widget.getParent().currentRow.CDFORNECED;
    };
    
    
    this.setObservacao = function(widget){
        let widgetFornecedor = templateManager.container.getWidget('fornecedor');
        let widgetObservacao = templateManager.container.getWidget('OBSERVACAO');
        let fieldObservacao = widgetObservacao.getField('DSOBSERVFORN');
        
        fieldObservacao.dataSourceFilter = [
            {
                "name": "CDFORNECED",
                "operator": "=",
                "value": widgetFornecedor.currentRow.CDFORNECED
            }
        ];
        
        if(templateManager.container.getActiveWidget() == widgetObservacao){
            fieldObservacao.reload().then(function(observacao){
                if(observacao){
                    if(observacao.dataset.observacao.length > 0){
                        widgetObservacao.currentRow.DSOBSERVFORN = observacao.dataset.observacao[0].DSOBSERVFORN;
                    } else {
                        widgetObservacao.currentRow.DSOBSERVFORN = "";
                    }   
                } else {
                    widgetObservacao.currentRow.DSOBSERVFORN = "";
                }
            });
        }
    };
    
    this.montarCurrentRowCtPagar = function(widget){
        let fornecedorWidget           = templateManager.container.getWidget('fornecedor');
        widget.currentRow.CDFORNECED     = fornecedorWidget.currentRow.CDFORNECED;
        widget.currentRow.CDTPBAIXAPAG   = fornecedorWidget.currentRow.CDTPBAIXAPAG;
        widget.currentRow.IDAGRUBOLFOR   = fornecedorWidget.currentRow.IDAGRUBOLFOR;
        widget.currentRow.IDTPTITULOCRED = fornecedorWidget.currentRow.IDTPTITULOCRED;
        widget.currentRow.DSTPTITULOCRED = fornecedorWidget.currentRow.DSTPTITULOCRED;
    };
    
    this.montarCurrentRowCtCorrente = function(widget){
        let fornecedorWidget           = templateManager.container.getWidget('fornecedor');
        
        widget.currentRow.CDFORNECED     = fornecedorWidget.currentRow.CDFORNECED;
        widget.dataSourceFilter[0].value = widget.currentRow.CDFORNECED;
    };
    
    this.deleteCtCorrente = function(widget){
        General.deleteCrud(widget).then(function(success){
            widget.reload();
            widget.getParent().reload();
        });
    };
    
    this.salvarContaPagar = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        
        if(widget.isValid()){
            fornecedorWidget.currentRow.CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
            fornecedorWidget.currentRow.IDAGRUBOLFOR = widget.currentRow.IDAGRUBOLFOR;
            fornecedorWidget.currentRow.IDTPTITULOCRED = widget.currentRow.IDTPTITULOCRED;
            fornecedorWidget.currentRow.DSTPTITULOCRED = widget.currentRow.DSTPTITULOCRED;
            General.callRestEngine('cadSup#/fornecedorControler/salvarContaPagar', 'Row', widget.currentRow).then(function(success) {
                self.setContaPagar(widget);
                self.habilitaAbas(widget);
                MessageService.successNotificationByCode("successOperation");
                widget.view();
                widget.activate();
                widget.reload();
            });
        }
    };
    
    this.setContaPagar = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        widget.currentRow.CDTPBAIXAPAG = fornecedorWidget.currentRow.CDTPBAIXAPAG;
        
        return General.callRestEngine('cadSup#/fornecedorControler/getTipoBaixa', 'Row', widget.currentRow).then(function(res) {
            let nmtpbaixapag = res.dataset.res.length ? res.dataset.res[0].NMTPBAIXAPAG : '';
            widget.currentRow.NMTPBAIXAPAG = nmtpbaixapag;
            widget.reload();
        });
    };
    
    this.setCdFornecedInterlocutores = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let interlocutorWidget = templateManager.container.getWidget('interlocutores');
        
        interlocutorWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
        if(templateManager.container.getActiveWidget() == interlocutorWidget){
            interlocutorWidget.reload();
        }
    };
    
    this.setFornecedorEnderecos = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let enderecoWidget = templateManager.container.getWidget('endereco');
        

        enderecoWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
        if(templateManager.container.getActiveWidget() == enderecoWidget){
            enderecoWidget.reload();
        }
    };
    
    this.setFornecedorParametrizacao = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let parametrizacaoWidget = templateManager.container.getWidget('parametrizacao');
        
        parametrizacaoWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
        if(templateManager.container.getActiveWidget() == parametrizacaoWidget){
            parametrizacaoWidget.reload();
        }
    };
    
    this.setFornecedorPagamento = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let pagamentoWidget = templateManager.container.getWidget('pagamento');
        
        pagamentoWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
        if(templateManager.container.getActiveWidget() == pagamentoWidget){
            pagamentoWidget.reload();
        }
    };
    
    this.setFornecedorFinanceiro = function(widget){
        let fornecedorWidget = templateManager.container.getWidget('fornecedor');
        let financeiroWidget = templateManager.container.getActiveWidget();
        let contaCorrenteWidget = templateManager.container.getWidget('contacorrente');
        let contaPagarWidget = templateManager.container.getWidget('contapagar');
        let codigosPixWidget = templateManager.container.getWidget('codigospix');
        
        

        if(contaCorrenteWidget == financeiroWidget){
            contaCorrenteWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
            contaCorrenteWidget.reload();
        }
        else if(contaPagarWidget == financeiroWidget){
            this.montarCurrentRowCtPagar(contaPagarWidget);
            this.setContaPagar(contaPagarWidget);
        }
        else if(codigosPixWidget == financeiroWidget){
            codigosPixWidget.dataSourceFilter[0].value = fornecedorWidget.currentRow.CDFORNECED;
            codigosPixWidget.reload();
        }
    };
    
    this.setFornecedorWidget = function(widget){
        let activeWidget = templateManager.container.getActiveWidget();
        let interlocutorWidget = templateManager.container.getWidget('interlocutores');
        let enderecoWidget = templateManager.container.getWidget('endereco');
        let observacaoWidget = templateManager.container.getWidget('OBSERVACAO');
        let parametrizacaoWidget = templateManager.container.getWidget('parametrizacao');
        let pagamentoWidget = templateManager.container.getWidget('pagamento');
        let contaCorrenteWidget = templateManager.container.getWidget('contacorrente');
        let contaPagarWidget = templateManager.container.getWidget('contapagar');
        let codigosPixWidget = templateManager.container.getWidget('codigospix');
        
        if(activeWidget == enderecoWidget){
            this.setFornecedorEnderecos(widget);
        }
        else if(activeWidget == parametrizacaoWidget){
            this.setFornecedorParametrizacao(widget);
        }
        else if(activeWidget == pagamentoWidget){
            this.setFornecedorPagamento(widget);
        }
        else if(activeWidget == contaCorrenteWidget  || activeWidget == contaPagarWidget || activeWidget == codigosPixWidget ){
            this.setFornecedorFinanceiro(widget);
        }
        else if(activeWidget == interlocutorWidget){
            this.setCdFornecedInterlocutores(widget);
        }
        else if(activeWidget == observacaoWidget){
            this.setObservacao(widget);
        }

    };
    
    this.callTipoForn = function(widget){
        if(widget.currentRow.CDTIPOFORN != null){
            General.callRestEngine('cadSup#/fornecedorControler/getTipoForn', 'Row', widget.currentRow).then(function(resp) {
                let dataResponse = resp.dataset;
                if(dataResponse.resp[0] == null){
                    widget.currentRow.NMTIPOFORN = "";
                }else{
                    widget.currentRow.NMTIPOFORN = dataResponse.resp[0].NMTIPOFORN;
                    widget.reload();
                }
            }).catch(function(callback) {
    	        showGenericError(callback);
            });
        }
    };
    
    this.verificaEditar = function(widget) {
        let row = widget.currentRow;
        if(row.CDFILIFORN == null && row.IDFUNCAOFILI != 'F' && row.FRANQUEADORA > 0) {
            widget.getAction('EDIT').isVisible = false;
            widget.getAction('DEL_FORN').isVisible = false;
            templateManager.container.getWidget('parametrizacao').getAction('EDIT').isVisible       = false;
            templateManager.container.getWidget('pagamento').getAction('EDIT').isVisible            = false;
            templateManager.container.getWidget('contacorrente').getAction('ADD').isVisible         = false;
            templateManager.container.getWidget('contacorrente').getAction('EDIT').isVisible        = false;
            templateManager.container.getWidget('contapagar').getAction('EDIT').isVisible           = false;
            templateManager.container.getWidget('interlocutores').getAction('ADD').isVisible        = false;
            templateManager.container.getWidget('interlocutores').getAction('EDIT').isVisible       = false;
            templateManager.container.getWidget('OBSERVACAO').getAction('EDIT').isVisible           = false;
        }  
        else {
            widget.getAction('EDIT').isVisible = true;
            widget.getAction('DEL_FORN').isVisible = true;
            templateManager.container.getWidget('parametrizacao').getAction('EDIT').isVisible       = true;
            templateManager.container.getWidget('pagamento').getAction('EDIT').isVisible            = true;
            templateManager.container.getWidget('contacorrente').getAction('ADD').isVisible         = true;
            templateManager.container.getWidget('contacorrente').getAction('EDIT').isVisible        = true;
            templateManager.container.getWidget('contapagar').getAction('EDIT').isVisible           = true;
            templateManager.container.getWidget('interlocutores').getAction('ADD').isVisible        = true;
            templateManager.container.getWidget('interlocutores').getAction('EDIT').isVisible       = true;
            templateManager.container.getWidget('OBSERVACAO').getAction('EDIT').isVisible           = true;
        }
    };
    
    this.ocultaInativarFornecedores = function (){
        templateManager.container.getWidget('fornecedor').getAction('INATIVAR').isVisible = false;
    };
    
    this.justIntegerr = function (selector, retryCount) {
		if (!retryCount || retryCount > 5)
			retryCount = 5;
		if (!selector) {
			throw {
				"message": "Selector is not defined!"
			};
		}
		setTimeout(function () {
			let elem = $(selector);
			if (elem[0]) {
				let length = selector.split(',').length;
				for (let i = 0; i < length; i++) {
					if (elem.hasOwnProperty(i)) {
						elem[i].onkeypress = avoidNonInteger;
						elem[i].onpaste = preventEvent;
					}
				}
			} else {
				if (!retryCount) {
					console.error("Selector not found!");
				} else {
					retryCount--;
					this.justIntegerr(selector, retryCount);
				}
			}
		}.bind(this), 500);
	};

	function avoidNonInteger(e) {
		let integerNumbers = [48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 40, 41, 42, 43, 45, 46];
		let numberCode = e.which;
		if (integerNumbers.indexOf(numberCode) < 0) {
			preventEvent(e);
		}
	}
	
	function preventEvent(e) {
		e.preventDefault();
	}
	
	this.validaFieldEnvioAf = function(widget){
	    if (widget.currentRow.IDTPENVAFFOR == '1') {
	        widget.getField('IDTPENVAFNORMAL').readOnly = false;
	    }else{
	        widget.getField('IDTPENVAFNORMAL').readOnly = true;
	    }
	    
	    if (widget.currentRow.IDTPENVAFNORMAL == null) {
            widget.currentRow.IDTPENVAFNORMAL = 'E';
            widget.getParent().currentRow.IDTPENVAFNORMAL = 'E';
        }
	};
	
    self.checkInscricaoParceiro = function(widget){
        let inscricao = widget.currentRow.NRINSJURFORN.replace(/\.|\/|\-/g, '');
        let promise = ZHPromise.defer();
        
        Sup00800_Fornecedor_Service.getParcNegocio(inscricao).then(function (success) {
            let parcnegocio = success.dataset.parcnegocio[0];
            if (parcnegocio) {
                let config = {
                    type: "question",
                    icon: "question",
                    success: function(){
                        widget.currentRow.NMRAZSOCFORN = parcnegocio.NMPRINCIPALPARC;
                        widget.currentRow.NMFANTFORN = parcnegocio.NMSECUNDARIPARC;
                        widget.currentRow.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                        promise.resolve();
                    },
                    fail: function(){
                        promise.reject();
                    }
                };
                MessageService.confirmMessageByCode("numeroInscricaoExistente", null, config);
            } else {
                promise.resolve();
            }
        }).catch(() => {
            promise.resolve();
        });
        return promise;
    };
    
    self.checkInscricao = function(widget) {
        let inscricao = General.inscricaoFormat(widget.currentRow.NRINSJURFORN);
        let promise = ZHPromise.defer();
        if(inscricao.valid) {
            widget.currentRow.NRINSJURFORN = inscricao.value;
            widget.currentRow.IDTPIJURFORN = inscricao.tipo.cod;
            
            let row = {
                CDFORNECED: inscricao.tipo.cod + inscricao.value    
            };  
            
            return General.callRestEngine("cadSup#/getFornecedorInscricao", "Row", row).then(function(success) {
                if(success.dataset.fornecedor[0]) {
                    let config = {
                        type: "question",
                        icon: "question",
                        success: function(confirm){
                            let fornecedor = success.dataset.fornecedor[0];
                            self.changeReadOnlyFieldsForn(widget, true, fornecedor);
                            fornecedorOutraFilial = true;
                            promise.resolve();
                        },
                        fail: function(error){
                            widget.currentRow.CDFORNECED = '';
                            widget.currentRow.NRINSJURFORN = '';
                            self.changeReadOnlyFieldsForn(widget, false, []);
                            fornecedorOutraFilial = false;
                            promise.reject();
                        }
                    };
                    MessageService.confirmMessageByCode("dadosFornced", null, config);
                }
                else {
                    fornecedorOutraFilial = false;
                    return self.checkInscricaoParceiro(widget);
                }
            }.bind(this), function(error) {   
                fornecedorOutraFilial = false;
                return self.checkInscricaoParceiro(widget); 
            }.bind(this));
            
        } else {
            showErrorInscricao(inscricao);
            widget.currentRow.NRINSJURFORN = null;
            promise.reject();
        }
        return promise;
    };
	
	this.getInfoCnpj = function(args){
	    let widget = args.owner.widget;
	    let widgetFornecedor = args.owner.widget.getParent();
	    let widgetEnderecoPrinc = templateManager.container.getWidget('endprinc');
	    let currentRow = args.owner.widget.currentRow;
	    
        if(!widget.isValid()) return;

	    currentRow.tpInscricao = General.inscricaoFormat(currentRow.INSCRICAO);
	    
	    General.callRestEngine("cadSup#/getInfoCnpj", "Row", currentRow).then(function(success) {
	        let dadosCadastrais = success.dataset.getInfoCnpj[0];
	        widgetFornecedor.getField('NRINSJURFORN').setValue(dadosCadastrais.CNPJ);
	        self.checkInscricao(widgetFornecedor).then(function(success){
    	        widgetFornecedor.currentRow.NMRAZSOCFORN = dadosCadastrais.xNome;
    	        widgetFornecedor.currentRow.NMFANTFORN   = dadosCadastrais.xFant? dadosCadastrais.xFant : dadosCadastrais.xNome;
	            widgetFornecedor.getField('NRINSESTFORN').setValue(dadosCadastrais.IE);
    	        self.criaCdforneced(widgetFornecedor);
                let dadosEnder = dadosCadastrais.ender;
                widgetEnderecoPrinc.currentRow.NRCEPFORN = dadosEnder.CEP;
                widgetEnderecoPrinc.currentRow.DSLOGRADOURO = dadosCadastrais.DSLOGRADOURO? dadosCadastrais.DSLOGRADOURO : '';
                widgetEnderecoPrinc.currentRow.DSLOGRADOURO = dadosCadastrais.DSLOGRADOURO? dadosCadastrais.DSLOGRADOURO : '';
                widgetEnderecoPrinc.currentRow.DSENDEFORN = dadosEnder.xLgr;
                widgetEnderecoPrinc.currentRow.NUMERO = !isNaN(dadosEnder.nro)? dadosEnder.nro : '';
                widgetEnderecoPrinc.currentRow.DSCOMPENDFOR = dadosEnder.xCpl;
                widgetEnderecoPrinc.currentRow.NMPAIS = dadosCadastrais.NMPAIS;
                widgetEnderecoPrinc.currentRow.CDPAIS = dadosCadastrais.CDPAIS;
                widgetEnderecoPrinc.currentRow.NMESTADO = dadosCadastrais.NMESTADO;
                widgetEnderecoPrinc.currentRow.SGESTADO = dadosCadastrais.SGESTADO;
                widgetEnderecoPrinc.currentRow.NMMUNICIPIO = dadosCadastrais.NMMUNICIPIO;
                widgetEnderecoPrinc.currentRow.CDMUNICIPIO = dadosCadastrais.CDMUNICIPIO;
                widgetEnderecoPrinc.currentRow.NMBAIRFORN = dadosCadastrais.NMBAIRFORN;
                widgetEnderecoPrinc.currentRow.CDBAIRRO = dadosCadastrais.CDBAIRRO;
                
                widgetFornecedor.activate();
                widgetFornecedor.openTab('endprinc');
                ScreenService.closePopup();
	        });
	    }).catch(function(callback) {
	        showGenericError(callback);
        });
	};
	
	function showGenericError(error){
        let errorMessage = "TIMEOUT";
        let textContentError = '';
        
        if (error.data){
            errorMessage = "ERR_GENERICO";
            textContentError = error.data.error;
        }
        MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError}, Constants.errorMessage);
    }
	
	this.openPopupConsultaCadastro = function (widget){
		let widPopupConsulta = templateManager.container.getWidget('popConsultaSituCad');
		widPopupConsulta.getField('INSCRICAO').setValue(widget.currentRow.NRINSJURFORN);
        widPopupConsulta.currentRow.SGESTADO = null;
        widPopupConsulta.currentRow.NMESTADO = null;
		ScreenService.openPopup(widPopupConsulta);
	};
	
	this.openPopupCopiarEndereco = function (widget){
		let widPopupCopiarEndereco = templateManager.container.getWidget('popCopiarEndereco');
		widPopupCopiarEndereco.getField('TipoEndereco').setValue("");
		ScreenService.openPopup(widPopupCopiarEndereco);
	};
	
	this.copiaEndereco = function(widgetPopup){
	    let widgetEndereco = templateManager.container.getWidget('endereco');
        let row = angular.copy(widgetEndereco.currentRow);
        const campoTipoEndereco = widgetPopup.getField('TipoEndereco');
        if(widgetPopup.isValid()){
            const tipoEndereco = campoTipoEndereco.value();
            tipoEndereco.forEach( type => {
                row.IDTPENDEFORN = type;
                let index = widgetEndereco.dataSource.data.findIndex( endereco => endereco.IDTPENDEFORN == type );
                row.__is_new = (index === -1);
                self.copiarEndereco(widgetEndereco, angular.copy(row), false);
                MessageService.successNotificationByCode("successOperation");
            });
            self.masterDetailGoBackToParent(widgetPopup);
            ScreenService.closePopup();
            self.reactivateTab(widgetEndereco);
            self.endefornCheckActions();
        }else{
            MessageService.showMessageByCode("preencherObrigatorios", null, Constants.alertMessage);
        }
	};
	
	this.closePopUpConsultaCadastro = function(args){
        ScreenService.closePopup();
        let widgetFornecedor = templateManager.container.getWidget('fornecedor');
        self.reactivateTab(widgetFornecedor);
	};

    this.reactivateTab = function(widgetTab){
        let masterDetailTabbed = widgetTab.currentWidget;
        if(masterDetailTabbed && masterDetailTabbed.name == 'masterDetailTabbedWidget'){
            masterDetailTabbed.currentWidget = widgetTab;
        }
    };
	
	this.readOnlyConsSituCad = function (widget){
	    
	    if(widget.currentRow.__is_new) 
	        widget.getField('btnConsSituCad').readOnly = false;
	    else
	        widget.getField('btnConsSituCad').readOnly = true;
	    
	};
	
    self.salvarCodigoPix = function(widget){
        if(!widget.isValid()){
            ScreenService.showMessage("Preencha todos os campos obrigatórios!");   
        }else{
            widget.currentRow.CDFORNECED = widget.getParent().getParent().currentRow.CDFORNECED;
            widget.currentRow.CDCHAVEPIX = widget.currentRow.CDCHAVEPIX.trim();
            let chave = {}, CDCHAVEPIX = widget.currentRow.CDCHAVEPIX;
            
            switch (widget.currentRow.IDCHAVEPIX) {
                case '01':
                    chave.valid = CDCHAVEPIX.length > 8 && typeof(parseInt(CDCHAVEPIX)) === 'number';
                    if(!chave.valid){
                        chave.message = "Celular inválido.";
                    }   
                    break;
                case '02':
                    chave = ValidationEngine.mail(CDCHAVEPIX, {});
                    break;
                case '03':
                    if(CDCHAVEPIX.length == 11){
                        chave.valid = General.validateCPF(CDCHAVEPIX);
                    }else if(CDCHAVEPIX.length == 14){
                        chave.valid = General.validateCNPJ(CDCHAVEPIX);
                    }else{
                        chave.valid = false;
                    }
                    if(!chave.valid){
                        chave.message = "CPF/CNPJ inválido.";
                    }   
                    break;
                
                case '04':
                    let ckchex  = new RegExp('^[0-9a-fA-F-]+$');
                    chave.valid = ckchex.test(CDCHAVEPIX);
                    if(!chave.valid){
                        chave.message = "EVP inválido.";
                    }   
                    break;
                
                default:
                    chave.valid = false;
                    chave.message = "Tipo de Chave Pix inválido.";
            }
            if (widget.isValid() && chave.valid){
                General.saveCrud(widget);
            }else{
                ScreenService.showMessage(chave.message||"Dados inválidos");
            }
        }
    };
    
     /**
     * Inicia o popup para inativar os fornecedores.
     *
     * @param void
     * @return void
     * 
     */

    self.startInativar = function() {
        const popUpInativar = templateManager.container.getWidget('popUpInativar');
		ScreenService.openPopup(popUpInativar);
    };
    
    /**
     * Verifica se a quantidade de meses está correta para operação e chama a rota para inativar os fornecedores.
     *
     * @param Object widget_pop
     * @return void
     * 
     */
    
    self.inativarFornecedores = function(widget_popup) {
        if(widget_popup.isValid()){
            const MESES_SEM_MOVIMENTACAO = widget_popup.getField('MESES_SEM_MOVIMENTACAO');
            let mensagem;
            
            if(!MESES_SEM_MOVIMENTACAO.value() || (MESES_SEM_MOVIMENTACAO.value() < 12 || MESES_SEM_MOVIMENTACAO.value() > 99) ) {
                MessageService.showMessageByCode('cadSup#FornecedoresInativadosMinMax');
                return;
            }
    
            MessageService.getMessageByCode('InativarFornecedores').then(function(response){
                mensagem = response.replace('__PARAMS__', MESES_SEM_MOVIMENTACAO.value());
            
                ScreenService.confirmMessage(mensagem, "question", () => {
        			const row = { 
                        MESES_SEM_MOVIMENTACAO: MESES_SEM_MOVIMENTACAO.value()
                    };
                    General.callRestEngine('cadSup#/inativar_fornecedores', 'Row', row).then((response) => {
                        ScreenService.closePopup();
                        MESES_SEM_MOVIMENTACAO.value(null);
                        if(response.dataset.fornecedoresInativados == ""){
                            MessageService.showMessageByCode('cadSup#semFornecedoresInativados');
                        } else {
                            widget_popup.getParent().reload();
                            MessageService.showMessageByCode('cadSup#FornecedoresInativados');
                            General.showErrorMessages(widget_popup, response.dataset.fornecedoresInativados, 'Fornecedores Inativados');
                        }
                    }).catch(function(callback) {
                        showGenericError(callback.error);
                    }); 
        		});
            });
        }
    };
    
     /**
     * Fecha o popUp de inativar os fornecedores e ativa a widget de fornecedor.
     *
     * @param void
     * @return void
     * 
     */
    

    self.closeInativarPopUp = function () {
        ScreenService.closePopup();
        templateManager.container.getWidget('fornecedor').activate();
    };


};

Configuration(function (ContextRegister){
    ContextRegister.register('Sup00800_Fornecedor_Controller', Sup00800_Fornecedor_Controller);
});

// FILE: ./assets/js/controllers/sup04100_fornecedor_inativoController.js
function sup04100_fornecedor_inativoController(General, ScreenService, localStorageEngine, ZhFilterPreferences, templateManager, MessageService, ZHPromise) {

    var self = this;

    this.constructFilter = function(widget) {
        
        ZhFilterPreferences.openFilterWidget(widget, {});
    };
   
    this.setStripeValues = () => {
        
        const widgetGrid = templateManager.container.getWidget('gridWidgetFornecedorInativo');
        const widgetStripe = templateManager.container.getWidget('STRIPE_WIDGET');
        
        const { INTERVAL_DT, TIPO } = widgetGrid.appliedFilter.FILTER_ROW;
        
       formatStripeDate(INTERVAL_DT).then(response => {
           widgetStripe.currentRow.DATA_DE_ENTREGA_STRIPE = response;
       });
        
        widgetStripe.currentRow.TIPO_STRIPE = TIPO && TIPO.length ?  TIPO : '';
    };
  
    function formatStripeDate (data_object) {

        let promise = ZHPromise.defer();
        
        if(data_object.period) {
            promise.resolve(data_object.period.label);
            return promise;
        }
        
        if(data_object.formattedEnd && data_object.formattedEnd === data_object.formattedStart) {
            
            promise.resolve(data_object.formattedStart);
            return promise;
            
        } else  {
            
            return MessageService.getMessageByCode('INTERVALO_DATA').then(response => {
                return ScreenService.i18n(response, { STARTDATE: data_object.formattedStart, FINISHDATE: data_object.formattedEnd });
            });
            
        }
        
    }
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('sup04100_fornecedor_inativoController', sup04100_fornecedor_inativoController);
});

// FILE: ./assets/js/controllers/zhFavorites.js
var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhNavbarDefaultHeader', function(templateManager, ScreenService, eventAggregator, $compile, ApplicationContext) {
	return {
		restrict: 'C',
		link: function($scope, element) {
		    $scope.favoritesList = [];
		    $scope.lastDeletedItem = undefined;
		    
		    var favoritesText = 'Favoritos';
		    var favoritesAddText = 'Adicionar aos Favoritos';
		    var favoritesRemoveText = 'Remover dos Favoritos';
		    var favoritesUndoText = 'DESFAZER';

			// TRANSLATE - Adicionar essas variaveis a lista da aplicação (words.jon)
		    // var favoritesText = ScreenService.i18n('FAVORITES');
		    // var favoritesAddText = ScreenService.i18n('ADD_TO_FAVORITES');
		    // var favoritesRemoveText = ScreenService.i18n('REMOVE_FROM_FAVORITES');
		    // var favoritesUndoText = ScreenService.i18n('UNDO');
		    
		    var favoritesContainer;
		    
		    var startHollowCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+
				'	<style type="text/css">'+
				'		.st0{fill:#FFFFFF;}'+
				'	</style>'+
				'	<g>'+
				'		<path class="st0" d="M15,4.21l3.51,7.1l7.84,1.14l-5.67,5.53l1.34,7.81L15,22.1l-7.01,3.69l1.34-7.81l-5.67-5.53l7.84-1.14L15,4.21'+
				'			 M15,2.21c-0.76,0-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05'+
				'			l4.92,4.8l-1.16,6.77c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2'+
				'			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8'+
				'			c0.55-0.53,0.74-1.33,0.51-2.05c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21L15,2.21z"/>'+
				'	</g>'+
				'</svg>';
		    var startFilledCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+
				'	<style type="text/css">'+
				'		.st0{fill:#FFFFFF;}'+
				'	</style>'+
				'	<g>'+
				'		<path class="st0" d="M28.25,11.83c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21'+
				'			s-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05l4.92,4.8l-1.16,6.77'+
				'			c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2'+
				'			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8'+
				'			C28.29,13.35,28.48,12.56,28.25,11.83z"/>'+
				'	</g>'+
				'</svg>';
		    
		    function createVisualElements() {
    			var headerContainer = $(element).children()[0];
    			headerContainer.style.width = 'calc(100% - 50px)';
    			
    			favoritesContainer = $('<div class="zh-favorites"></div>').appendTo(element);
    			
    			var favoritesButtonElement = $compile(
    				'<div class="zh-favorites-button" ng-click="toggleList()">'+
    				'  <div class="zh-favorites-button-star" ng-if="!isFavorited">'+
    				'    '+startHollowCode+
    				'  </div>'+
    				'  <div class="zh-favorites-button-star" ng-if="isFavorited">'+
    				'    '+startFilledCode+
    				'  </div>'+
    				'  <div class="zh-favorites-button-text">'+favoritesText+'</div>'+
    				'</div>'
    			)($scope);
    			var favoritesButton = $(favoritesButtonElement).appendTo(favoritesContainer);
    			
    			var favoritesListElement = $compile(
    				'<div class="zh-favorites-list" ng-class="{\'opened\': opened}">'+
    				'  <div class="zh-favorites-list-button" ng-if="!isFavorited" ng-click="addToFavorites()">'+favoritesAddText+'</div>'+
    				'  <div class="zh-favorites-list-button" ng-if="isFavorited" ng-click="removeFromFavorites()">'+favoritesRemoveText+'</div>'+
    				'  <div class="zh-favorites-list-undo" ng-show="lastDeletedItem" ng-click="undo()">'+favoritesUndoText+'</div>'+
    				'  <div class="zh-favorites-list-items" ng-show="favoritesList.length > 0">'+
    				'	 <div class="zh-favorites-list-item" ng-repeat="item in favoritesList track by item.id" ng-click="openItem(item)">'+
    				'      {{ item.label }}'+
    				'      <span class="zh-favorites-list-item-delete" data-zh-icon="trash icon-white no-border" ng-click="deleteItem(item, $index, $event)"></span>'+
    				'    </div>'+
    				'  </div>'+
    				'</div>'
    			)($scope);
    			var favoritesList = $(favoritesListElement).appendTo(favoritesContainer);
		    }
		    
		    function checkIsFavorited(containerId) {
		    	var oldIsFavorited = $scope.isFavorited;
			    $scope.isFavorited = $scope.favoritesList.findIndex((item) => item.id === containerId) !== -1;
			    if (oldIsFavorited !== $scope.isFavorited) {
			    	templateManager.updateTemplate();
			    }
		    }
		    
		    $scope.addToFavorites = function() {
		    	var item = {
		    		id: templateManager.container.id,
		    		name: templateManager.container.fileName.split('.json')[0],
		    		label: templateManager.container.label,
		    	};
		    	$scope.favoritesList.push(item);
		    	$scope.isFavorited = true;
		    	eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'add' }});
		    };
		    
		    $scope.removeFromFavorites = function() {
		    	var index = $scope.favoritesList.findIndex((item) => item.id === templateManager.container.id);
		    	if (index > -1) {
			    	var item = $scope.favoritesList.splice(index, 1);
			    	$scope.isFavorited = false;
			    	eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'delete' }});
		    	}
		    };
		    
		    $scope.openItem = function(item) {
		    	ApplicationContext.LibUtilities.openWindow(item.name);
	    		$scope.opened = false;
		    };
		    
		    var undoTimeout;
		    
		    $scope.deleteItem = function(item, index, event) {
		    	$scope.favoritesList.splice(index, 1);
		    	$scope.lastDeletedItem = { item, index };

		    	clearTimeout(undoTimeout);
		    	undoTimeout = setTimeout(() => {
		    		$scope.lastDeletedItem = undefined;
		    		templateManager.updateTemplate();
		    	}, 10000);

			    eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item, status: 'delete' }});

		    	if (item.id === templateManager.container.id) {
		    		$scope.isFavorited = false;
		    	}

		    	event.stopImmediatePropagation();
		    };
		    
		    $scope.undo = function() {
		    	if ($scope.lastDeletedItem) {
		    		$scope.favoritesList.splice($scope.lastDeletedItem.index, 0, $scope.lastDeletedItem.item);
		    	}
		    	$scope.lastDeletedItem = undefined;
		    };

		    $scope.toggleList = function() {
		    	$scope.opened = !$scope.opened;
		    };
		    
		    document.addEventListener('mousedown', (evt) => {
		    	if ($(favoritesContainer).find(evt.target).length === 0 && $scope.opened) {
		    		$scope.opened = false;
			    	templateManager.updateTemplate();
		    	}	
		    });
		    
		    eventAggregator.subscribe(eventAggregator.ON_CONTAINER_OPEN, (args) => {
		    	checkIsFavorited(args.container.id);
		    });
		    
		    eventAggregator.subscribe('ZhFavoritesOnLoad', (favorites) => {
		    	
		    	$scope.favoritesList = favorites;
			    if (templateManager.container) {
			    	checkIsFavorited(templateManager.container.id);
			    }
		    });

		    createVisualElements();
		}
	};
});
